c-- sir code for list                            Release 93.02
code for bldsc
      block data bldsc
c--define block data for disc routines
c
      common/xbufd/link(1600)
      common/xdisc/iacc,ilss,iadd1,nfwd,nwd,nv,nwb,nwr,i,j,k,l,m,n,nnn
      common/xfile/ifile,ilist,iend,infle,nwfle,icfle,lid(4)
      common/xfili/lfirst,nwblo,lindex(240)
      common/xchar/id,ie,ib,ic,ia,ih
     1 ,numb(10),iplus, inus,ipoint
      common/xcard/nch,image(80),nc,nd,ni,nt,na(3),ncd,idoc(20)
      common/xmate/itdf(9), m1d,m2d,n1d,n2d
      common/lst06/l6,l6a,l6d,ld6p,m6,m6dk,n6dk,md6d,n6d,n6,n6p,
     2 l6rs,l6rk,l6in,l6p,k1,k2,k3
      common/xlimi/nfl,lfl,nl,idummy(3),nfls
      common /data/ store(5000)
c
      data nwblo/50/,ifile/10000/,ilist/11000/,iend/11111/
      data infle/240/,nwfle/6/,icfle/-1/,lfirst/1600/
      data iacc/-1/,ilss/15/,nfl/1/,lfl/5000/,nl/5000/
      data ncd/-1/,nfls/1/
      data id/1h(/,ie/1h)/,ib/1h /,ic/1h,/
      data ia/1h*/,ih/1h#/
      data numb( 1)/1h0/,numb( 2)/1h1/,numb( 3)/1h2/,numb( 4)/1h3/
      data numb( 5)/1h4/,numb( 6)/1h5/,numb( 7)/1h6/,numb( 8)/1h7/
      data numb( 9)/1h8/,numb(10)/1h9/
      data iplus/1h+/, inus/1h-/,ipoint/1h./
      data nch/2/
      data nc/-1/,nd/-1/,ni/-1/
      end
c
code for star9
      subroutine star9
c--initialize the disc routines
c
      li=1
      lf=800
      call xgiv(li,lf,i)
      return
      end
c
code for xup
      subroutine xup(nfw,iadd,nw)
c--transfer from store to disc
c
c  nfw   address of first word to be used on disc
c  iadd  address of first word in core
c  nw    number of words to transfer
c
c--disc routines version iv, using 'link ' array as store
c  the buffers.
c
c--record 0 contains words  0   - (nwr-1)
c  record 1 contains words  nwr - (2*nwr-1)
c  and subsequent records are the same
c
c--
      common/xbufd/link(1600)
      common/xdisc/iacc,ilss,iadd1,nfwd,nwd,nv,nwb,nwr,i,j,k,l,m,n,nnn
c--
      dimension iadd(nw)
c
c--transfer the arguments to the common block
      nfwd=nfw
      nwd=nw
      nv=1
c--check if there are any more words to transfer
1200  continue
      if(nwd)1250,1250,1300
1250  continue
      return
c--calculate the record number etc. for this transfer
1300  continue
      call  xfndb
c--write some numbers
      link(i+3)=-1
      do 2050 m=j,k
      link(m)=iadd(nv)
      nv=nv+1
2050  continue
      go to 1200
      end
c
code for xdwn
      subroutine xdwn(nfw,iadd,nw)
c--transfer from disc to store
c
c  nfw   address of first word to be used on the disc
c  iadd  address of first word in core
c  nw    number of words to transfer
c
c--disc routines version iv, using 'link ' array as store
c  the buffers.
c
c--record 0 contains words  0   - (nwr-1)
c  record 1 contains words  nwr - (2*nwr-1)
c  and subsequent records are the same
c
c--
      common/xbufd/link(1600)
      common/xdisc/iacc,ilss,iadd1,nfwd,nwd,nv,nwb,nwr,i,j,k,l,m,n,nnn
c
      dimension iadd(nw)
c
c--transfer the arguments to the common block
      nfwd=nfw
      nwd=nw
      nv=1
c--check if there are any more words to transfer
1200  continue
      if(nwd) 1250,1250,1300
1250  continue
      return
c--calculate the record number etc. for this transfer
1300  continue
      call xfndb
c--read some numbers
      do 1950 m=j,k
      iadd(nv)=link(m)
      nv=nv+1
1950  continue
      go to 1200
      end
c
code for xgiv
      subroutine xgiv(iadd0,nnl,llu)
c--set up the user defined buffers
c
c  iadd0  first free address in 'link' that can be used
c  nnl    length of user buffer area
c  llu    first word that may be used by the user (set on return)
c
c--
      common/xbufd/link(1600)
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common/xdisc/iacc,ilss,iadd1,nfwd,nwd,nv,nwb,nwr,i,j,k,l,m,n,nnn
c
c--set the number of words per block equal to the number per record
      nwr=knwr
      nwb=nwr
      l=(nnl-4)/(nwb+4)
      iacc=-1
      llu=iadd0
      if(l) 2500,2500,2300
2300  continue
      l=min0(l,ilss)
      iadd1=iadd0
      link(iadd1)=-10000
      i=iadd1+4
      j=iadd1
      go to 2400
c--link the next buffer
2350  continue
      link(i)=j
      link(j+1)=i
      link(i+2)=-10000
      link(i+3)=0
      j=i
      i=i+nwb+4
      l=l-1
c--check if any more buffers can be link in
2400  continue
      if(l) 2450,2450,2350
c--set the last buffer flag
2450  continue
      link(j+1)=-10000
      iacc=1
      llu=i
2500  continue
      return
      end
c
code for xfndb
      subroutine xfndb
c--find the required disc buffer
c
c--arguments are in the common block :
c
c  iadd1  first buffer word in 'link'
c  nfwd   current disc address
c  nwd    number of words left to transfer
c  nv     current position in the input or output array
c
c--the above variables are set on entry, and reset as necessary on exit.
c
c--the following variables are also set on exit :
c
c  i  address of the current buffer
c  j  address of the first word in the buffer for data
c  k  address of the last word in the buffer for data
c
c--the following variables must not changed :
c
c  l
c  m
c  n
c
c--
      common/unit/lxn,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/xbufd/link(1600)
      common/xdisc/iacc,ilss,iadd1,nfwd,nwd,nv,nwb,nwr,i,j,k,l,m,n,nnn
c
c--check if the buffers have been allocated
      if(iacc)1050,1150,1150
c--attempt to read or write before declaring buffers
1050  continue
      write(lo,1100)
1100  format(' *** error *** no buffers allocated to the disc routines')
      stop 46
c--calculate the record number etc. of transfers to be made
1150  continue
      nr =nfwd/ nwb
      n =nfwd-nr* nwb
c--search through the buffer list for free buffers and/or the buffer
c  containing this record
      i=link(iadd1+1)
      j=iadd1
c--check the first buffer to see if this is the correct one
      if(nr-link(i+2))1400,1750,1400
c--check if this is the correct buffer
1350  continue
      if(nr-link(i+2))1400,1700,1400
c--check for a free buffer wich also indicates the end of the stack
1400  continue
      if(link(i+2))1650,1450,1450
c--check if this is the last buffer
1450  continue
      if(link(i+1)) 1550,1550,1500
c--pick up the next buffer
1500  continue
      j=i
      i=link(i+1)
      go to 1350
c--rewrite the contents of the last buffer to the disc if nec.
1550  continue
      if(link(i+3)) 1600,1650,1650
1600  continue
      m=link(i+2)
      call xstor(m,link(i+4),nwb)
      link(i+3)=0
c--fetch the record of interest
1650  continue
      link(i+2)=nr
      call xftch(nr,link(i+4),nwb)
c--switch this buffer to the top of the buffer stack
c  all other buffers are forced one down the stack, so that the
c  least used one ends up at the end
1700  continue
      link(j+1)=link(i+1)
      link(i+1)=link(iadd1+1)
      link(iadd1+1)=i
1750  continue
c--calculate the number of words that can be transfered from this buffer
      j=i+n+4
      k=j+nwd-1
      l=i+3+nwb
      nwd=k-l
c--check if all the words are in this buffer
      if(nwd)1850,1850,1800
1800  continue
      k=l
      nfwd=nfwd+(k-j+1)
1850  continue
      return
      end
c
code for xdump
      subroutine xdump
c--rewrite all the buffers marked for writing to the disc
c
      common/xbufd/link(1600)
      common/xdisc/iacc,ilss,iadd1,nfwd,nwd,nv,nwb,nwr,i,j,k,l,m,n,nnn
c
c--check if any buffers are allocated
      if(iacc)2800,2550,2550
c--link into the first buffer
2550  continue
      i=link(iadd1+1)
      j=-1
c--check if the buffer required writing
2600  continue
      if(link(i+3))2650,2700,2700
c--write the buffer out
2650  continue
      j=link(i+2)
      call xstor(j,link(i+4),nwb)
      link(i+3)=0
c--check if this is the last buffer
2700  continue
      if(link(i+1)) 2800,2800,2750
2750  continue
      i=link(i+1)
      go to 2600
2800  continue
      return
      end
c
code for xftch
      subroutine xftch(i,j,k)
c--fetch data from the disc  -  this link controls the disc
c
c  i  disc address of the information in user records
c  j  array into which the data goes
c  k  number of words to read
c
c**this link is machine specific as it relates the
c  length of records seen by the user to the length
c  of hardware blocks on the disc
c
c--
      common/xdisu/ncdfu ,ndfle,irecx
      common/unit/lxn,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      dimension j(512)
c
c**machine specific - relates the block length to the user record length
      n=i+1
      read(unit=ncdfu,rec=n,iostat=ier,err=1010)(j(m),m=1,k)
      return
1010  continue
      l=kwlnt(k)
      do 1015 m=1,l
      j(m)=0
1015  continue
      write(unit=ncdfu,rec=n,iostat=ier,err=1030)(j(m),m=1,l)
      return
1030  continue
      write(lo,1020) ier,ncdfu
1020  format(' xftch: ',i5,' error - unit =',i5)
      stop 100
      end
c
code for xstor
      subroutine xstor(i,j,k)
c--store data on the disc - this link controls the disc
c
c  i  disc address of the information in user records
c  j  address in store into which the data goes
c  k  number of words to read
c
c**this link is machine specific as it relates the
c  length of records seen by the user to the length
c  of hardware blocks on the disc
c
c--the transfer is rounded up to fill one or more disc blocks
c
c--
      common/xdisu/ncdfu ,ndfle,irecx
      common/unit/lxn,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      dimension j(512)
c
c**machine specific - relates block length to the user record length
      m=kwlnt(k)
      n=i+1
      write(unit=ncdfu,rec=n,iostat=ier,err=1010) (j(l),l=1,m)
      return
1010  continue
      write(lo,1020) ier
1020  format(' xstor: ',i5,' error')
      stop 200
      end
c
code for kwlnt
      function kwlnt(in)
c--assigns the number of words to complete a record
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      i=knwr
      kwlnt=(in+i-1)/i*i
      return
      end
c
code for setfi
      subroutine setfi
c--initialize the binary disc file
c  by creating the first file index
c
      common/unit/lxn,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/xfile/ifile,ilist,iend,infle,nwfle,icfle,lid(4)
      common/xfili/lfirst,nwblo,lindex(240)
c
c--find the initial constants
      do 990 i=1,nwblo
      lindex(i)=-10000
990   continue
      i=infle
      j=nwblo
      k=j+i
      lindex(1)=lfirst+k
      lindex(2)=i
      lindex(3)=lfirst+j
      lindex(4)=j
      m=11
      lindex(5)=m
      lindex(6)=nwfle
      lindex(8)=ifile
      do 1000 l=1,20
      lindex(m)=itle(l)
      m=m+1
1000  continue
      call xup (lfirst,lindex,j)
      m=infle/nwfle-1
      lindex(1)=ifile
      lindex(2)=m
      lindex(3)=lfirst+j
      lindex(4)=lfirst+k-1
      lindex(5)=nwfle
      lindex(6)=i
      l=nwfle+1
      do 1010 i=1,m
      do 1010 k=1,nwfle
      lindex(l)=0.0
      l=l+1
1010  continue
      i=lindex(6)
      call xup (lindex(3),lindex,i)
      call xdump
      call sldf
      return
      end
c
code for sldf
      subroutine sldf
c--load the  file index
c
      common/unit/lxn,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
c
      if(jsldf(in)) 1010,1005,1005
1005  continue
      return
1010  continue
c--error because the file index has been corrupted
      write(lo,1020)
1020  format(/,34h the file index has been corrupted)
      stop 1111
      end
c
code for jsldf
      function jsldf(in)
c--load the details of the file index when beginning to use a file
c
      common/unit/lxn,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/xfile/ifile,ilist,iend,infle,nwfle,icfle,lid(4)
      common/xfili/lfirst,nwblo,lindex(240)
c--
      jsldf=0
      call xdwn (lfirst,lindex,10)
      i=lindex(4)
      call xdwn (lfirst,lindex,i)
      j=lindex(5)
      do 1000 k=1,20
      itle(k)=lindex(j)
      j=j+1
1000  continue
      i=lindex(2)
      call xdwn (lindex(3),lindex,i)
c--check that the file index is correctly set up or  has been
c  corrupted
      if(lindex(1)-ifile) 1010,1005,1010
1005  continue
      return
1010  continue
      jsldf=-1
      go to 1005
      end
c
code for xlc
      subroutine xlc
c--initial subroutine to load all the file index information
c
      common/xfile/ifile,ilist,iend,infle,nwfle,icfle,lid(4)
c
      if(icfle)1000,1010,1010
1000  continue
      call sldf
      icfle=1
1010  continue
      return
      end
c
code for xnxtf
      subroutine xnxtf(ll)
c--assign the next free location
c
      common/xfili/lfirst,nwblo,lindex(240)
      dimension  loc(1)
      call xdwn (lfirst, loc,1)
      ll= loc(1)
      return
      end
c
code for snxtf
      subroutine snxtf(ll)
c--write the value of ~ll~  as the new next free location
c
      common/xfili/lfirst,nwblo,lindex(240)
      dimension  loc(1)
       loc(1)=ll
      call xup (lfirst,loc,1)
      call xdump
      return
      end
c
code for swlin
      subroutine swlin (iln,lsn,lfw,llw,lpb,ll)
c--write the entry for a newly created list into the file index
c
c  iln  the list type number
c  lsn  the list serial number
c  lfw  first word accupied by the list
c  llw  last word occupied by the list
c  lpb  the lenght of the preamble block for a block type list
c  ll   list lenght
c
      common/unit/lxn,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/xfili/lfirst,nwblo,lindex(240)
c
      call xlc
      if (iln) 1000,1000,1010
1000  continue
      write(lo,1001) iln
1001  format(///,i7,25h is not a valid list type)
      stop  1111
1010  continue
      mln=lindex(2)
      il =lindex(5)
      if(iln-mln) 1030,1030,1000
1030  continue
      i=iln*il+1
      lindex(i  )=iln
      lindex(i+1)=lsn
      lindex(i+2)=lfw
      lindex(i+3)=llw
      lindex(i+4)=lpb
      lindex(i+5)=ll
      j=lindex(6)
      call xup (lindex(3),lindex,j)
      return
      end
c
code for srlin
      subroutine srlin (iln,lsn,lfw,llw,lpb,ll)
c--read the entry  for a list in the current index table
c
c  iln  the list type number
c  lsn  the list serial number
c  lfw  first word occupied by the list
c       'lfw' is set negative if no such list exists
c  llw  last word occupied by the list
c  lpb  the lenght of the preamble block for a block type list
c  ll   list lenght
c
      common/xfili/lfirst,nwblo,lindex(240)
c
      if(iln)1020,1020,1000
1000  continue
      call xlc
      mln=lindex(2)
      il =lindex(5)
      if(iln-mln) 1010,1010,1020
1010  continue
      i=iln*il+1
      if(lindex(i)) 1020,1020,1040
1020  continue
      lfw=-1
1030  continue
      return
1040  continue
      lsn=lindex(i+1)
      lfw=lindex(i+2)
      llw=lindex(i+3)
      lpb=lindex(i+4)
      ll=lindex(i+5)
      go to 1030
      end
c
code for xcln
      subroutine xcln(in)
c--set on the store the first values of the list @in@
c
      common/xlimi/nfl,lfl,nl,nflmx,lflmx,nlmx,nfls
      common/xfile/ifile,ilist,iend,infle,nwfle,icfle,lid(4)
c
      common /data/ store(5000)
c
      store(nfl  )=float(iend)
      store(nfl+1)=float(in)
      store(nfl+2)=1.0
      store(nfl+3)=0.0
      store(nfl+4)=-1.0
      return
      end
c
code for sfrml
      subroutine sfrml (iln, n)
c--form a list
c
c  iln list number
c  n   the lenght of the list
c
c  the list is assumed to begin at @nfl@
c
      common/xlimi/nfl,lfl,nl,nflmx,lflmx,nlmx,nfls
      common /unit/lxn,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
c
      common /data/ store(5000)
      dimension istore(5000)
      equivalence (store(1),istore(1))
c
      ln=n
      call sowl(ln,iln,lsn,lfw,llw,lpb,ll)
      if (iln) 1000,1000,1030
1000  write(lo,1010) iln
1010  format(/,i7,' is not a valid list type')
      return
1030  continue
      store(nfl+2)=lsn
      call xup(lfw,istore(nfl),n )
      call swlin(iln,lsn,lfw,llw,lpb,ln)
      call xdump
      return
      end
c
code for sowl
      subroutine sowl  (lcl,iln,lsn,lfw,llw,lpb,ll)
c--write or overwrite a list on the disc
c
c  lcl  lenght that has to be written
c  iln  list number
c  lsn  list serial number
c  lfw  location of first word on the disc
c  llw  location of the last word on the disc
c  lpb  lenght of the preamble block of the list to be overwritten
c  ll   list lenght
c
c--find the list of this type
      lsn=0
      call srlin (iln,lsn,lfw,llw,lpb,ll)
      if(lfw) 1020,1020,1010
c--check if the current list is of the right lenght
1010  continue
      if(ll-lcl) 1020,1060,1060
c--list can not be overwritten
c--find the next free location
1020  continue
      call xnxtf(ll)
      lfw=ll
      llw=lfw+lcl
      call snxtf(llw)
      llw=llw-1
      lpb=0
1060  continue
      ll=lcl
      lsn=lsn+1
      return
      end
c
code for sldl
      subroutine sldl (iln,lsn,lfw,llw)
c--load list into store
c  iln  list type number
c  lsn  list serial number
c  lfw  location of the first word of the list in store
c  llw  location of the last word of the list in store
c
c--the  list is brought up from the bottom of the store,
c  ~lfw~and~llw~ are set on return
c
      common/xlimi/nfl,lfl,nl,nflmx,lflmx,nlmx,nfls
c
      call srlin (iln,lsn,li,lj,lk,ll)
      lfw=nfl
      llw=lfw+ll-1
      call xsac(iln,lsn,lfw,llw)
      call srdls(iln,lsn,lfw,l)
      return
      end
c
code for srdls
      subroutine srdls(iln,lsn,lfw,lll)
c--read a list from the disc
c
c  iln  list type number
c  lsn  list serial number - set on return
c  doc  array to hold the list
c  lll  number of words to bring down - if zero the whole list
c       is brought down,and@ll@ is set to the number of words read
c
c--for lists with a  reamble block,only the preamble block is read,
c  and @lll@ is set negative on return
c
      common/unit/lxn,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
c
      common /data/ store(5000)
      dimension istore(5000)
      equivalence (store(1),istore(1))
c
      call srlin (iln,lsn,li,lj,lk,ll)
      if(li) 1000,1000,1020
1000  continue
      write(lo,1010) iln
1010  format(///,16h no list of type,i5,8h  stored,/)
1015  continue
      stop 1111
1020  continue
      if(lk) 1040,1040,1030
1030  continue
      ll=lk
1040  continue
      lll=ll
      nll=lll
      call xdwn(li,istore(lfw),nll)
      il=store(lfw+1)
      if(il-iln)1061,1063,1061
1061  continue
      write(lo,1062)iln
1062  format(//,' requested list',i4,' has been corrupted')
      go to 1015
1063  continue
      if(lk) 1080,1080,1070
1070  continue
      lll=-lll
1080  continue
      return
      end
c
code for xsac
      subroutine xsac(iln,lsn,lfw,llw)
c--storage allocation control - this subroutine also
c  checks that the store limits have not been exceeded
c
c  iln list type that is being used for this data type
c  lsn  list serial number
c  lfw  first word used in 'store'
c  llw  last word used in 'store'
c--
      common/xlimi/nfl,lfl,nl,nflmx,lflmx,nlmx,nfls
      common/unit/lxn,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/xsae/ ncl,lis(4,39)
c--
 
      if(ncl) 980,980,950
950   continue
      do 970 i=1,ncl
      if(iln-lis(1,i)) 970,960,970
960   continue
      j=i
      go to 990
970   continue
980   continue
      ncl=ncl+1
      j=ncl
990   continue
      lis(1,j)=iln
      lis(2,j)=lsn
      lis(3,j)=lfw
      lis(4,j)=llw
      if(nfl+5-lfl) 1000,1000,1010
1000  continue
      return
1010  continue
      write(lo,1020)iln
1020  format(32h1***store overflow*** (list type,i5,1h))
      call xpas
      stop
      end
c
code for xcsae
      subroutine xcsae
c--clear storage allocation entries
c
      common/xsae/ ncl,lis(4,39)
      ncl=0
      return
      end
c
code for xpas
      subroutine xpas
c--print allocated store
      common/xlimi/nfl,lfl,nl,nflmx,lflmx,nlmx,nfls
      common/unit/lxn,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/xsae/ ncl,lis(4,39)
c--
c--check if any entries are waiting to be printed
      if(ncl) 1035,1035,990
990   continue
      write(lo,1000)
1000  format(///,18h allocated store :,//,5x,
     2 9hlist type,4x,10hserial no.,9x,7haddress,9x,6hlength,/)
      do 1030 i=1,ncl
      l=lis(4,i)-lis(3,i)+1
      write(lo,1020)(lis(k,i),k=1,4),l
1020  format(    2i13,i14,4h  to,i7,i10)
1030  continue
1035  continue
      l=lfl-nfl+1
      write(lo,1040)nfl,lfl,l
1040  format(//,19h free location(s) : ,i7,4h to ,i7,
     2 2h, ,i7,9h word(s) )
      return
      end
c
code for komp
      function kcomp(nw,itest,iarg,narg,nsarg)
c--standard comparision routine
c
c  nw     number of separate words to be compared
c  itest  vector holding the word(s) to be compared
c  iarg   vector holding the wrods against which the comparision is to
c         be made
c  narg   number of standard words to compare against
c  nsarg  the step beteen successive comparision words
c
c-- on return kcomp holds the position of the find or else -1
c
c--
      dimension itest(nw),iarg(narg)
      i=1
      j=1
1000  continue
      if(narg-i)1010,1030,1030
1010  continue
      kcomp=-1
1020  continue
      return
1030  continue
      k=1
      l=j
1040  continue
      if(itest(k)-iarg(l)) 1080,1050,1080
1050  continue
      if(nw-k)1060,1060,1070
1060  continue
      kcomp=i
      go to 1020
1070  continue
      k=k+1
      l=l+1
      go to 1040
1080  continue
      i=i+1
      j=j+nsarg
      go to 1000
      end
c
code for jrca
      function jrca(ja,n)
c--read an holerith string terminated by a blank or comma
c  into the array 'ia' and put the number of characters read
c  into 'n'
c
c--the input variables are :
c
c  ia the array to hold the character string (a2 format)
c  n  the number of characters read  -  number of words used
c     is equal to (n+1)/2
c
c--
      common/xchar/id,ie,ib,ic,ia,ih
     1 ,numb(10),iplus, inus,ipoint
      dimension ja(40)
c--
      j=jrcx(ja,n,ib,2)
      jrca=j
      return
      end
c
code for jrcx
      function jrcx(ja,n,j,k)
c--read a holerith character string, terminated by one of the
c  characters contained into yhe vector 'j', putting the result
c  into 'ia' and the number of characters into 'n'
c
c-- jrcx is set as follows on return :
c
c  -1  character string not found
c   0  all okay
c
c--input values are :
c
c  ja the array to hold the character string (a2 format)
c  n  the number of characters read  -  number of words used
c     is equal to (n+1)/2
c  j  the vector containing the characters that is to terminate
c     the string (a1 format)
c  k  number of characters in 'j'
c
c--
      common/xchar/id,ie,ib,ic,ia,ih
     1 ,numb(10),iplus, inus,ipoint
      common/xcard/nch,image(80),nc,nd,ni,nt,na(3),ncd,idoc(20)
      dimension ja(40)
      dimension j(k)
c
c--set up the initial constats
      i=0
      jn=0
      jrcx=0
      nd=kne(nc,j,k)
      if(nd) 1010,1010,1020
1010  continue
      jrcx=-1
      go to 1100
1020  continue
c--determine the length of the character string
      nc=keq(nd,j,k)
      if(nc) 1030,1030,1040
1030  continue
      nc=81
1040  continue
      n=nc-nd
      call scomp(image(nd),ja,n)
1100  continue
      return
      end
c
code for kne
      function kne(nc,nd,n)
c--search a card for the character not of type 'nd'
c
c  nc  character position at which to start
c  nd  the vector containing the characters which the current
c      character must not be
c  n   number of characters in 'nd'
c
c--kne returns set to the position of the first character not
c  equal to 'nd', or else to -1.
c
      common/xcard/nch,image(80),idm(3),nt,na(3),ncd,idoc(20)
      dimension nd(n)
c--
      i=nc
      kne=-1
      if(i) 1000,1000,1001
1001  if(i-nt-1) 1002,1000,1000
1002  continue
      do 1004 l=1,n
      if(image(i)-nd(l)) 1004,1006,1004
1004  continue
      go to 1005
1006  continue
      i=i+1
      go to 1001
1005  kne=i
1000  continue
      return
      end
c
code for keq
      function keq(nc,nd,n)
c--find the next character on a card
c
c  nc  character position at which to start
c  nd  the vector containing the characters to search for
c  n   number of characters in 'nd'
c
c--keq is set to the character position , or -1 if the character
c  can not be found
c
      common/xcard/nch,image(80),idm(3),nt,na(3),ncd,idoc(20)
      dimension nd(n)
c--
      i=nc
      keq=-1
      if(i) 1000,1000,1001
1001  if(i-nt-1) 1002,1000,1000
1002  continue
      do 1004 l=1,n
      if(image(i)-nd(l)) 1004,1005,1004
1004  continue
      i=i+1
      go to 1001
1005  keq=i
1000  continue
      return
      end
c
code for jredi
      function jredi(in)
c--like kredi function
c
c--no searching for the first blank character
c
c--
      common/xchar/id,ie,ib,ic,ia,ih
     1 ,numb(10),iplus, inus,ipoint
      common/xcard/nch,image(80),nc,nd,ni,nt,na(3),ncd,idoc(20)
c--set up the initial constants
      i=0
      j=1
c--search for the first non-blank character
      continue
      nc=kne(nc,id,4)
      if(nc) 1010,1010,1020
c--return sequence
1010  continue
      jredi=i*j
      return
c--check if first character is @+@ or @-@
1020  continue
      if(image(nc)-iplus)1030,1050,1030
1030  continue
      if(image(nc)- inus)1060,1040,1060
1040  continue
      j=-j
1050  continue
      nc=nc+1
      if(nc-nt-1) 1060,1010,1010
1060  continue
      do 1080 k=1,10
      if(image(nc)-numb(k)) 1080,1070,1080
1070  continue
      i=i*10+k-1
      go to 1050
1080  continue
c--remove any decimal points and numbers thereafter
      if(image(nc)-ipoint)1010,1090,1010
1090  continue
      nc=nc+1
      if(nc-nt-1) 1100,1010,1010
1100  continue
      do 1110 k=1,10
      if(image(nc)-numb(k)) 1110,1090,1110
1110  continue
      go to 1010
      end
c
code for jredf
      function jredf(a,n)
c--read n floating point number
c
c--jredf is set as follows on return :
c
c  -1  hash function found or spurious character found
c   0  all the numbers read correctly
c   1  not all the number have been read
c
c--
      common/xchar/id,ie,ib,ic,ia,ih
     1 ,numb(10),iplus, inus,ipoint
      common/xcard/nch,image(80),nc,nd,ni,nt,na(3),ncd,idoc(20)
c--
      dimension a(n)
      do 1000 i=1,n
      a(i)=0.0
1000  continue
      jredf=0
      do 1030 i=1,n
      nc=kne(nc,ib,2)
      if(nc) 1010,1010,1020
1010  continue
      jredf=1
      return
1020  continue
      if(kredf(a(i),1)) 1040,1030,1040
1030  continue
      return
1040  continue
      jredf=-1
      return
      end
c
code for kredf
      function kredf(store,non)
c--read floating point numbers
c
c--kreadf is set as follows on return :
c
c  -1  hash function found
c   0  numbers read    correctly
c   1  spurious character found
c
c--input values are :
c
c  store the array in to which the numbers should go
c  non   the number of numbers to read
c
c
c--this routine does not use fortran input processor and is thus
c  able to recover any data errors.
c
c--a number is terminated by one or more spaces,or the end of a card.
c
c--
      common/xchar/id,ie,ib,ic,ia,ih
     1 ,numb(10),iplus, inus,ipoint
      common/xcard/nch,image(80),nc,nd,ni,nt,na(3),ncd,idoc(20)
      dimension store(non)
c--
      kredf=0
      j=non
      k=1
8000  continue
      if(j) 8120,8120,8010
c--search for non-black characters
8010  continue
      nc=kne(nc,ib,2)
      if(nc) 8020,8020,8090
c--card change
8020  continue
c--directive or end of file on this card
      kredf=-1
      go to 8120
c--read a number
8090  continue
      if(kinpt(store(k))) 8100,8110,8100
c--spurious character found
8100  continue
c-----call xspch
      nc=keq(nc,ib,2)
      kredf=1
      go to 8120
8110  continue
      k=k+1
      j=j-1
      go to 8000
8120  continue
      return
      end
c
code for kinpt
      function kinpt(a)
c--read a number from a card
c
c  the numeric value is put in 'a'
c
c--error functions are indicated by the value of kinput on return
c
c  -1  first character does not indicate a number in this position
c   0  number read correctly
c   1  spurious character found after the first character read
c
c--on entry, the card character pointer ('nc') is assumed to be
c  pointing at first character of the number - i.e.  this
c  routine does not skip over blank spaces at the start.
c
c--a number is terminated by one or more spaces or the end  of a card
c
c--
      common/xchar/id,ie,ib,ic,ia,ih
     1 ,numb(10),iplus, inus,ipoint
      common/xcard/nch,image(80),nc,nd,ni,nt,na(3),ncd,idoc(20)
c--
c--set up the initial constants
      j=nc
      t=0.
      s=1.
      r=10.
      q=1.
      p=1.
c--check the first character to be read
      if(image(nc)-iplus)1000,1050,1000
1000  continue
      if(image(nc)- inus) 1020,1010,1020
1010  continue
      s=-1.
      go to 1050
1020  continue
      if (image(nc)-ipoint)1100,1040,1100
c--check if this is  the first '.' found
1030  continue
      if(p-0.5) 1130,1130,1040
c--reset for reading after the '.'
1040  continue
      r=1.
      q=0.1
      p=0.1
1050  continue
      nc=nc+1
c--check if this is end of card
      if(nc-nt-1) 1060,1070,1070
c--check if this is the end of the number - ' '
1060  continue
      if(image(nc)-ib    ) 1090,1070,1090
1070  continue
      kinpt=0
1075  continue
      a=t*s
      return
1090  continue
      if(image(nc)-ipoint)1100,1030,1100
c--find the numeric equivalent of the character and add in
1100  continue
      do 1120  i=1,10
      if(image(nc)-numb(i)) 1120,1110,1120
1110  continue
      t=t*r+float(i-1)*q
      q=q*p
      go to 1050
1120  continue
c--check if an error occurs on the first character read
      if(j-nc) 1130,1140,1130
1130  continue
      kinpt=-1
      go to 1075
1140  continue
      kinpt=1
      go to 1075
      end
c
code for scomp
      subroutine scomp(ja,jb,i)
c--compress two characters in one word
c
c  ja  vector holding the characters
c  jb  vector holding the words
c  i   number of characters to compress
c
c--
      common/xcard/nch,idum(108)
      character*80  ibuf
      dimension ja(i),jb(i)
c
c--clear buffer
      ibuf=' '
      write(ibuf,1000)(ja(j),j=1,i)
1000  format(80a1)
      i1=(i+nch-1)/nch
      read(ibuf,1010)(jb(j),j=1,i1)
1010  format(40a2)
      return
      end
c
code for trasf
      subroutine trasf(store,temp,k)
c--auxiliary subroutine for transfering data
c
c  store output vector
c  temp  input vector
c  k  number of words
c
      dimension temp(k),store(k)
c
      li1=1
      j1=1
      do 1000 n=1,k
      store(li1)=temp(j1)
      li1=li1+1
      j1=j1+1
1000  continue
      return
      end
c
code for xmtmt
      subroutine xmtmt(a,b,c,l,m,n)
c--a(l,m).b(n,m)'=c(l,n)
      common/xmate/itdf(9), m1d,m2d,n1d,n2d
      dimension a(9),b(9),c(9)
      m1d=l
      m2d=1
      n1d=n
      n2d=1
      call xmtmr(a,b,c,l,m,n)
      return
      end
c
code for xmtmr
      subroutine xmtmr(a,b,c,l,m,n)
c--main matrix multiplication routine
      common/xmate/itdf(9), m1d,m2d,n1d,n2d
      dimension a(9),b(9),c(9)
      l1=1
      n2=1
      do 1030 j=1,n
      m2=1
      do 1020 i=1,l
      c(l1)=0.
      m1=m2
      n1=n2
      do 1010 k=1,m
      c(l1)=c(l1)+a(m1)*b(n1)
      m1=m1+m1d
      n1=n1+n1d
1010  continue
      l1=l1+1
      m2=m2+m2d
1020  continue
      n2=n2+n2d
1030  continue
      return
      end
c
      subroutine minv9( a,iv)
c
c---- calcola l'inversa della matrice a e la
c---- memorizza in iv
c---- alfa e' la matrice aggiunta
c
      dimension  a(3,3),iv(9), alfa(3,3)
c
      alfa(1,1)=a(2,2)*a(3,3)-a(2,3)*a(3,2)
      alfa(1,2)=-1*(a(2,1)*a(3,3)-a(2,3)*a(3,1))
      alfa(1,3)=a(2,1)*a(3,2)-a(2,2)*a(3,1)
      alfa(2,1)=-1*(a(1,2)*a(3,3)-a(1,3)*a(3,2))
      alfa(2,2)=a(1,1)*a(3,3)-a(1,3)*a(3,1)
      alfa(2,3)=-1*(a(1,1)*a(3,2)-a(1,2)*a(3,1))
      alfa(3,1)=a(1,2)*a(2,3)-a(1,3)*a(2,2)
      alfa(3,2)=-1*(a(1,1)*a(2,3)-a(1,3)*a(2,1))
      alfa(3,3)=a(1,1)*a(2,2)-a(1,2)*a(2,1)
      det=a(1,1)*alfa(1,1)+a(1,2)*alfa(1,2)+a(1,3)*alfa(1,3)
      l=1
      do 10 i=1,3
      do 10 j=1,3
      iv(l)=alfa(i,j)/det
      l=l+1
10    continue
      return
      end
c
code for frm01
      subroutine frm01(ax)
c--form list 1 , unit cell constants
c
      common/unit/lxn,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      dimension  ad(9),bd(9),cd(9),sd(9),ar(9),br(9),cr(9),sr(9)
      common/trig/sint(450),pi,twopi,dtor,rtod
c
      common/xlimi/nfl,lfl,nl,idummy(3),nfls
      common /data/ store(5000)
      dimension istore(5000)
      equivalence(store,istore)
c
      dimension ax(6)
c--
      nfl=nfls
      call xcln(1)
      l=nfl+200
      l1=l
      do 1003 i=1,6
      store(l1)=ax(i)
      l1=l1+1
1003  continue
c--check if the cosines or the angles have been input
      l1=l+3
      l2=l+6
      l3=l+9
      if(store(l+3)-1.5) 1010,1100,1100
1010  continue
      do 1015 i=1,3
      store(l2)=store(l1)
      a=store(l2)
      store(l3)=sqrt(1.0-a*a)
      b=store(l3)
      store(l1)=atan2(b,a)
      l1=l1+1
      l2=l2+1
      l3=l3+1
1015  continue
      go to 1200
1100  continue
      do 1105 i=1,3
      store(l1)=store(l1)*dtor
      b=store(l1)
      store(l2)=cos(b)
      store(l3)=sin(b)
      l1=l1+1
      l2=l2+1
      l3=l3+1
1105  continue
c--calculate the reciprocal parameters
1200  continue
      l1=l
      do 1222 i=1,3
      ad(i)=store(l   )
      bd(i)=store(l+ 3)
      cd(i)=store(l+ 6)
      sd(i)=store(l+ 9)
      l=l+1
1222  continue
      j=2
      k=3
      do 1212 i=1,3
      cr(i)=(cd(j)*cd(k)-cd(i))/(sd(j)*sd(k))
      sr(i)=sqrt(1.0-cr(i)*cr(i))
      br(i)=atan2(sr(i),cr(i))
      j=j+1
      if(j-3) 1112,1112,1122
1122  continue
      j=j-3
1112  continue
      k=k+1
      if(k-3) 1212,1212,1201
1201  continue
      k=k-3
1212  continue
      j=2
      k=3
      do 1312 i=1,3
      ar(i)=1.0/(ad(i)*sd(j)*sr(k))
      j=j+1
      if(j-3) 1232,1232,1221
1221  continue
      j=j-3
1232  continue
      k=k+1
      if(k-3) 1312,1312,1301
1301  continue
      k=k-3
1312  continue
      l=l1
      do 1322 i=1,3
      store(l+12)=ar(i)
      store(l+15)=br(i)
      store(l+18)=cr(i)
      store(l+21)=sr(i)
      l=l+1
1322  continue
      l=l1
      m=l+12
      vr=store(m)*store(m+1)*store(m+2)*
     2  store(m+9)*store(m+10)*store(l+11)
      v=1.0/vr
      lk=nfl+5
      do 1300 i=1,6
      store(lk)=store(l)
      store(lk+7)=store(l+12)
      lk=lk+1
      l=l+1
1300  continue
      store(lk)=v
      store(lk+7)=vr
      l=nfl+200
      lk=nfl+19
      lj=lk+35
      do 1310 li=lk,lj
      store(li)=0.0
1310  continue
      lk=nfl+37
c--calculate orthogonalization matrix for real space
      store(lk  )=store(l  )*store(l+10)*store(l+23)
      store(lk+3)=-store(l  )*store(l+10)*store(l+20)
      store(lk+6)=store(l  )*store(l+7)
      store(lk+4)=store(l+1)*store(l+9)
      store(lk+7)=store(l+1)*store(l+6)
      store(lk+8)=store(l+2)
      lk=lk+9
c--calculate orthogonalization matrix for reciprocal space
      store(lk  )=store(l+12)
      store(lk+1)=store(l+13)*store(l+20)
      store(lk+2)=store(l+14)*store(l+19)
      store(lk+4)=store(l+13)*store(l+23)
      store(lk+5)=-store(l+14)*store(l+22)*store(l+6)
      store(lk+8)=1.0/store(l+2)
c--calculate the real and reciprocal metric tensor
      li=nfl+37
      do 1320 j=1,9
      ad(j)=store(li)
      li=li+1
1320  continue
      call xmtmt (ad,ad,sd,3,3,3)
      li=nfl+19
      lk=nfl+46
      do 1330 j=1,9
      store(li)=sd(j)
      li=li+1
      ad(j)=store(lk)
      lk=lk+1
1330  continue
      call xmtmt(ad,ad,sd,3,3,3)
      li=nfl+28
      do 1340 j=1,9
      store(li)=sd(j)
      li=li+1
1340  continue
c--write the list 1 to the disc
      n =55
      call sfrml (1,n )
      return
      end
code for yfl01
      subroutine yfl01
c--form absolute list 1 in store
c
c--the locations in store are controlled by the following variables
c
c  l1p1  location real cell parameters
c  l1p2  location of the reciprocal parameters
c  l1m1  location of the real metric tensor
c  l1m2  location of the reciprocal metric tensor
c  l1o1  location of the real orthogonalization matrix
c  l1o2  location of the reciprocal orthogonalization matrix
c  l1c   location of the coefficients needed to convert the
c        isotropic temperature factor to the aniso off diagonal
c        terms  (=cos(a*))
c  l1s   terms of the r(ij)=s
c  l1a   coefficients needed for the aniso temperature factor
c
c--
      common/unit/lxn,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/rc/p(6),cx(9),dumm(9)
      common/trig/sint(450),pi,twopi,dtor,rtod
c--
      common/xlimi/ nfl,idummy(5),nfls
      common/lst01/l1p1,l1p2,l1m1,l1m2,l1o1,l1o2,l1a,l1c,l1s
      common /data/ store(5000)
      dimension  istore(5000)
      equivalence(store,istore)
c--
      nfl=nfls
      twopis=2.0*pi*pi
      call srlin(1,lsn,li,lj,lk,ll)
      if(li.le.0) return
      call sldl(1,ly,li,lz)
      lii=li
      l1p1=li+5
      l1p2=l1p1+7
      l1m1=l1p2+7
      l1m2=l1m1+9
      l1o1=l1m2+9
      l1o2=l1o1+9
      l1a =lz+1
      l1c =l1a+6
      l1s =l1c+3
      nfl=l1s+6
      ljj=nfl-1
c--set up the necessary coefficients
      j=l1c
      k=l1p2+3
      l=l1s
      m=l1m2
      n=l1a
      i1=3
      do 1000 i=1,3
      store(j)=cos(store(k))
      store(l)=0.25*store(m)
      store(n)=-twopis*store(m)
      j=j+1
      k=k+1
      l=l+i1
      i1=i1-1
      m=m+4
      n=n+1
1000  continue
c--set up the off diagonal terms
      store(l1s+1)=0.5*store(l1m2+1)
      store(l1s+2)=0.5*store(l1m2+2)
      store(l1s+4)=0.5*store(l1m2+5)
      store(n  )=-2.*twopis*store(l1p2+1)*store(l1p2+2)
      store(n+1)=-2.*twopis*store(l1p2  )*store(l1p2+2)
      store(n+2)=-2.*twopis*store(l1p2  )*store(l1p2+1)
      call xsac(  1,ly,lii,ljj)
      p(1)=store(l1s  )
      p(2)=store(l1s+3)
      p(3)=store(l1s+5)
      p(4)=store(l1s+1)
      p(5)=store(l1s+2)
      p(6)=store(l1s+4)
      cx(1)=store(l1p1  )
      cx(2)=store(l1p1+1)
      cx(3)=store(l1p1+2)
      cx(4)=store(l1p1+3)*rtod
      cx(5)=store(l1p1+4)*rtod
      cx(6)=store(l1p1+5)*rtod
      cx(7)=sin(store(l1p1+3))
      cx(8)=sin(store(l1p1+4))
      cx(9)=sin(store(l1p1+5))
      return
      end
c
code for yfrm02
      subroutine yfrm02
c--form list 2 , symmetry positions
c
      common /erl/ ksmat(48,3,3),tmat(48,3),nt(16),lsys,ngen
     *,irot(48,48),ivet(10),jvet(8),nori,modul(3),nss(3)
      common/sym/is(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emme
     *          ,s3s2p
c
      common/xlimi/nfl,lfl,nl,idummy(3),nfls
      common /data/ store(5000)
      dimension istore(5000)
      equivalence(store,istore)
      dimension iv(9)
c--
      nfl=nfls
      call xcln(2)
      if(latt.eq.1) il=1
      if(latt.eq.2) il=5
      if(latt.eq.3) il=6
      if(latt.eq.4) il=7
      if(latt.eq.5) il=2
      if(latt.eq.6) il=4
      if(latt.eq.7) il=3
      mm=13
      l2=nfl+mm
      md2=12
      ngen=0
      ic=icent+1
      ngo=nsym*ic
      n2=nsym
c--
      store(nfl+5)=float(il )
      store(nfl+6)=float(ic)
      store(nfl+7)=float(n2 )
      store(nfl+8)=float(lsys)
      store(nfl+9)=nori
      store(nfl+10)=mm
      store(nfl+11)=float(ngen)
      store(nfl+12)=mm+n2*md2
      l2=nfl+mm
      m2=l2
      do 90 i=1,n2
      do 70 j=1,3
      do 70 k=1,3
      store(m2)=ksmat(i,j,k)
   70 m2=m2+1
      do 80 j=1,3
      store(m2)=tmat(i,j)
   80 m2=m2+1
   90 continue
      m2s=m2
      do 1300 j=1,16
      istore(m2s)=nt(j)
      m2s=m2s+1
1300  continue
      do 1310 j=1,10
      istore(m2s)=ivet(j)
      m2s=m2s+1
1310  continue
      do 1320 j=1,8
      istore(m2s)=jvet(j)
      m2s=m2s+1
1320  continue
      do 1340 i=1,3
      istore(m2s  )=modul(i)
      istore(m2s+3)=nss  (i)
      m2s=m2s+1
1340  continue
      m2s=m2s+3
      istore(m2s)=1
      m2s=m2s+1
      m2=l2+md2
      do 30 i=2,n2
      call minv9(store(m2),iv)
      mm2=l2
      do 20 j=1,n2
      l=mm2
      do 10 k=1,9
      if(store(l).ne.iv(k))go to 19
      l=l+1
10    continue
      istore(m2s)=j
      go to 29
19    continue
      mm2=mm2+md2
20    continue
      stop 333
29    continue
      m2=m2+md2
      m2s=m2s+1
30    continue
      do 1330 j=1,ngo
      do 1330 i=1,ngo
      istore(m2s)=irot(j,i)
      m2s=m2s+1
1330  continue
      nn=m2s-nfl
c--write the list 2 to the disc
      call sfrml(2,nn)
      return
      end
c
code for yfl02
      subroutine yfl02
c--load list 2 in common area
c
c  the variables are used as follows :
c
c  ic     centro (1) or non-centro (0)
c  il     lattice type (1-7)
c  g2     scale constants to convert the /fc/'s onto the absolute scale
c  isys   crystal family
c  ngen   number of generator
c  l2     location of the first word of the first symmetry matrix
c  md2    number of words per matrix  (=12)
c  n2     number of matrices
c  l2s    location of the first word of the space group symbol
c  l2i    location of the first word of the correlation matrix
c         (ngoxngo where ngo=n2x(ic+1) )
c  l2t    location of the temporary storage
c  md2t   number of words per temporary location  (=10)
c  n2t    number of temporary locations (=n2)
c  n2p    the number of speararte shift vectors needed to describe
c         this lattice
c  md2p   number of words per shift vectors
c
      common/unit/lxn,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common /erl/ ksmat(48,3,3),tmat(48,3),nt(16),lsys,ngen
     *,irot(48,48),ivet(10),jvet(8),nori,modul(3),nss(3)
      common/sym/is(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emme
     *          ,s3s2p
      common/lst02/ic,il,g2,isys,ngex,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i
c
      common/xlimi/ nfl,idummy(5),nfls
      common /data/ store(5000)
      common/trig/sint(450),pi,twopi,dtor,rtod
      dimension  istore(5000)
      equivalence(store,istore)
      dimension hl(12)
c
      nfl=nfls
      twopis=2.0*pi*pi
      call srlin(2,lsn,li,lj,lk,ll)
      if(li.le.0) return
      call sldl(2,ly,li,lz)
      l2=     store(li+10) +li
      n2=     store(li+7)
      md2=12
      isys=    store(li+8)
      nsym=n2
      lsys=isys
      nori=    store(li+9)
      ngen=    store(li+11)
      m2s=     store(li+12)+li
      l2s=m2s
      l2a=l2s+16
      l2b=l2a+10
      l2c=l2b+8
      l2d=l2c+6
      l2i=l2d+n2
      n2t=n2
      md2t=10
      l2t=lz+1
      ljj=l2t+n2t*md2t-1
      ic=     store(li+6)
      il=     store(li+5)
      icent=ic  - 1
c
      if(il.eq.1) latt=1
      if(il.eq.5) latt=2
      if(il.eq.6) latt=3
      if(il.eq.7) latt=4
      if(il.eq.2) latt=5
      if(il.eq.4) latt=6
      if(il.eq.3) latt=7
      mm=13
      l2=nfl+mm
      md2=12
      ngo=nsym*ic
c--
      m2=l2
      do 90 i=1,n2
      do 70 j=1,3
      do 70 k=1,3
      ksmat(i,j,k)=store(m2)
   70 m2=m2+1
      do 80 j=1,3
      tmat(i,j)=store(m2)
   80 m2=m2+1
   90 continue
      m2=l2s
      do 1300 j=1,16
      nt(j)=istore(m2)
      m2=m2+1
1300  continue
      m2=l2a
      do 1310 j=1,10
      ivet(j)=istore(m2)
      m2=m2+1
1310  continue
      m2=l2b
      do 1320 j=1,8
      jvet(j)=istore(m2)
      m2=m2+1
1320  continue
      m2=l2c
      do 1340 i=1,3
      modul(i)=istore(m2)
      nss(i)=istore(m2+3)
      m2=m2+1
1340  continue
      m2=l2i
      do 1330 j=1,ngo
      do 1330 i=1,ngo
      irot(j,i)=istore(m2s)
      m2s=m2s+1
1330  continue
c
      md2p=3
      n2p=il
      if(il-4)1410,1410,1400
1400  continue
      n2p=2
1410  continue
      do 1520 i=1,3
      hl(i)=0.
1520  continue
      go to (1700,1600,1630,1650,1600,1600,1600),il
c--'i' , 'a' , 'b' or 'c' centred lattice
1600  continue
      do 1610 i=4,6
      hl(i)=0.5
1610  continue
      if(il-4) 1700,1700,1620
1620  continue
      hl(il-1)=0.
      go to 1700
c--'r' centred lattice
1630  continue
      do 1640 i=5,6
      hl(i  )=0.66666667
      hl(i+3)=0.33333333
1640  continue
      hl(4)=hl(8)
      hl(7)=hl(5)
      go to 1700
c--'f' centred lattice
1650  continue
      k=4
      do 1670 i=4,12,4
      do 1660 j=1,3
      hl(k)=0.5
      k=k+1
1660  continue
      hl(i)=0.
1670  continue
1700  continue
c--define the scale factor to convert the /fc/'s
      g2=store(li+5)
      if(g2-4.5)1030,1030,1020
1020  continue
      g2=2.
1030  continue
      if(g2-0.1)1040,1050,1050
1040  continue
      g2=1.
1050  continue
      pts=g2
      g2=g2*store(li+6)
      call xsac(2,ly,li,ljj)
      call musym(ksmat,tmat,n2,is,ts)
      return
      end
c
code for yfrm03
      subroutine yfrm03(ier)
c--form list 3, form factors
c
      character blank,digit*12,card(100)*80,ffile*80
      common /chara/ blank,digit,card,ffile
      common/unit/lxn,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nat,f(9),nalf(8)
c
      common/xchar/id,ie,ib,ic,ia,ih
     1 ,numb(10),iplus, inus,ipoint
      common/xcard/nch,image(80),nc,nd,ni,nt,na(3),ncd,idoc(20)
      common/xlimi/nfl,lfl,nl,idummy(3),nfls
      common /data/ store(5000)
      dimension istore(5000)
      equivalence(store,istore)
      dimension ibuf(40),fnum(8)
c--
      ierr=0
      iwac=1
      nlenf=136
      itype=2
      iform=1
      if(jopen(kform,ffile,nlenf,itype,iform,ierr)) 9200,1013,1013
1013  continue
      ja=20
      n3=nk
      do 1000 i=1,nk
      fnum(i)=nw (i)
1000  continue
      n3a=n3
c--form list 3
      nfl=nfls
      call xcln(3)
      store(nfl+4)=1.0
      md3=18
      store(nfl+5)=float(n3)
      store(nfl+6)=12.0
      store(nfl+7)=md3
      store(nfl+8)=iwac
      lz=nfl+12
c
c--read the title on the file
      nta=nt
      nt=80
      rewind kform
      do 2005 i=1,40
      ibuf(i)=ib
2005  continue
      read(kform,2006,iostat=ierr,err=9100)(ibuf(i),i=1,40)
2006  format(40a2)
c--read number of records per atomic specie
      if(jrcrd(kform).eq.-1) then
                               write(lo,9110) ffile
                               ier=-1
                               return
                             endif
      ncard=jredi(in)
      if(ncard.ge.iwac+3)goto 2010
      write(lo,9110) ffile
      goto 9300
c--read the contents for each atomic specie
2010  continue
      if(jrcrd(kform).eq.-1) go to 9000
      if(jrca(ibuf,n)) 9100,2030,9100
2030  continue
      i=kcomp(1,ibuf,nalf,n3,1)
      if(i) 2100,2100,2040
2040  continue
      nc=1
      n3a=n3a-1
      if(jst03(lz,md3,fnum(i),ncard,iwac,kform)) 9100,2050,3100
2050  continue
      if(n3a) 3000,3000,2010
2100  continue
      do 2150 i=1,ncard-1
      if(jrcrd(kform).eq.-1) return
2150  continue
      go to 2010
c--close the 'form$' file
3000  continue
      close(kform,iostat=ierr,err=9100)
      n=lz-nfl
      call sfrml(3,n)
3100  continue
      nt=nta
      return
 9000 continue
      write(lo,9010)
 9010 format(' *** error ***  atom type not expected', / ,
     *       '               check content directive ')
      ier=-1
      return
9100  continue
      if (ierr.eq.0) then
                       write(lo,9110) ffile
                     else
                       write(lo,9120) ierr,ffile
                     endif
 9110 format(' *** error ***  possible file corrupted. file is ',a)
 9120 format(' *** error ***  read error, code =',i5,' file is ',a)
      go to 9300
9200  continue
      write(lo,9210) ffile
9210  format(' *** error ***  file not found, file is ',a)
9300  ier=-1
      return
      end
c
code for jrcrd
      function jrcrd(ncsu)
c--read a record from a file
c
      common/unit/lxn,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/xchar/id,ie,ib,ic,ia,ih
     1 ,numb(10),iplus, inus,ipoint
      common/xcard/nch,image(80),nc,nd,ni,nt,na(3),ncd,idoc(20)
c--
      jrcrd=0
      do 2012 i=1,80
      image(i)=ib
2012  continue
      read(ncsu,2013,iostat=ier,err=9100,end=3100) (image(i),i=1,80)
2013  format(80a1)
      nc=1
      return
9100  continue
      write(lo,9110) ier,ncsu
9110  format(' *** error ***  read error ',i5,' on channel ',i2)
3100  continue
      jrcrd=-1
      return
      end
c
code for jst03
      function jst03(lz,md3,fn,ncard,iwac,ncsu)
c--store in list 3 the information contained in the $form$ file
c
      common/unit/lxn,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/xlimi/nfl,lfl,nl,idummy(4)
      dimension temp(40)
c
      common /data/ store(5000)
      dimension istore(5000)
      equivalence(store,istore)
      dimension ibuf(10)
c--
      jst03=0
      ja=1
      if(jrca(ibuf,n)) 9100,2030,9100
2030  continue
      lx=lz
      istore(lx  )=ibuf(1)
      store(lz+12)=fn
      if(jredf(temp(ja),4)) 9100,2050,2050
2050  continue
      call trasf(store(lz+13),temp(ja),3)
      store(lz+17)=temp(ja+3)
      if(jrcrd(ncsu).eq.-1) go to 9000
      if(jrca(ibuf,n)) 9100,2070,9100
2070  continue
      if(istore(lx)-ibuf(1)) 9100,2080,9100
2080  continue
      if(kredf(temp(ja),6)) 9100,2090,9100
2090  continue
      call trasf(store(lz+3),temp(ja),6)
      if(jrcrd(ncsu).eq.-1) goto 9000
      if(jrca(ibuf,n)) 9100,2095,9100
2095  continue
      if(istore(lx)-ibuf(1)) 9100,2097,9100
2097  continue
      if(kredf(temp(ja),3)) 9100,2098,9100
2098  continue
      call trasf(store(lz+9),temp(ja),2)
      store(lz+2)=temp(ja+2)
      goto(2200,2210),iwac
2200  continue
      if(jrcrd(ncsu).eq.-1) goto 9000
      read(ncsu,2007)
      goto 2300
2210  continue
      read(ncsu,2007)
2007  format(1x)
      if(jrcrd(ncsu).eq.-1) goto 9000
2300  continue
      if(jrca(ibuf,n)) 9100,2310,9100
2310  continue
      if(istore(lx)-ibuf(1)) 9100,2320,9100
2320  continue
      if(kredf(temp(ja),3)) 9100,2330,9100
2330  continue
      store(lz+1)=temp(ja)
      store(lz+11)=temp(ja+1)
      store(lz+16)=temp(ja+2)
      lz=lz+md3
      return
9000  continue
      jst03=1
      return
9100  continue
      jst03=-1
      return
      end
c
code for yfl03
      subroutine yfl03
c--form absolute list 3
c
c  l3  location of the information for the first form factor
c  n3  number of form factors
c
c--
      common/lst03/l3,m3,md3,n3,l3t,m3t,l3ti,m3ti,l3g,n3g,sys03
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nat,f(9),nalf(8)
      common/xlimi/ nfl,idummy(5),nfls
      common /data/ store(5000)
      dimension  istore(5000)
      equivalence(store,istore)
c--
      nfl=nfls
      call sldl(3,ly,l3g,lz)
      n3=     store(l3g+5)
      l3=     store(l3g+6) +l3g
      md3=    store(l3g+7)
      l=lz-1
      call xsac(3,ly,li,l)
      nk=n3
      m3=l3
      nat=0
      do 1000 i=1,n3
      nalf(i)=istore(m3)
      nw(i)= store(m3+12)
      no(i)= store(m3+13)
corig cl(i)=store(m3+1)+store(m3+2)
      cl(i)=store(m3+2)
      if (no(i).gt.1) nat=nat+nw(i)
      m3i=m3+3
      do 1100 j=1,4
      al(j,i)=store(m3i )
      bs(j,i)=store(m3i+1)
      m3i=m3i+2
1100  continue
      m3=m3+md3
1000  continue
      return
      end
c
code for yfl06
      subroutine yfl06(in,nrifl)
c--set up list 6 for reading and possibly writing
c
c--the common variables are used as follows
c
c  l6    disc location for writing
c  l6d   disc location for reading
c  m6    location of the core buffer at which the results are found
c  m6dk  location of the input (or output) disc buffer
c  n6dk  number of integer words in the disc buffer
c  md6d  number of real words per reflections on read
c  n6    number of reflections to be read
c  n6d   number of reflections written
c  l6p   address in store of the preamble block
c  n6p   length of the preamble block
c  ld6p  disc location of the preamble block
c  l6rs  location of the first scale factor for writing
c  l6rk  location of the first scale factor for reading
c  l6in  location of the first sorting codex
c
c  in = 0  prima chiamata
c  in = 1  successive letture
c
      common/sym/is(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emme
     *          ,s3s2p
      common/rc/p(6),cx(9),nreg,nb,rhomax,mm,en,mz,er,th,rhomin
c     common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,nonos,iprin,iflag
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,ifper,iprin,iflag
      common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,bt,sc,del,ks
      common/lst06/l6,l6a,l6d,ld6p,m6,m6dk,n6dk,md6d,n6d,n6,n6p,
     2 l6rs,l6rk,l6in,l6p,k1,k2,k3
      common/xlimi/ nfl,idummy(5),nfls
      common /data/ store(5000)
      dimension  istore(5000)
      equivalence(store,istore)
c--
      if(in.ne.0)go to 1000
c--load the preamble of list 6
      nfl=nfls
      k3=128
      k2=128*k3
      k1=128*k2
      inm=6
      call srlin(inm,li,ld6p,lk,ln,lm)
      n6p=ln
      l6p=nfl
      call srdls(inm,l,l6p,lj)
      md6d= store(l6p+5)
      n6dk= store(l6p+6)
      n6d = store(l6p+7)
      n6  = n6d
      nrifl=n6d
      ihx(1)=store(l6p+10)
      ihx(2)=store(l6p+11)
      ihx(3)=store(l6p+12)
c     jpart =store(l6p+15)
c     knw   =store(l6p+16)
c     bt    =store(l6p+17)
c     sc    =store(l6p+18)
c     mm    =store(l6p+19)
c     mz    =store(l6p+20)
c     s3s2  =store(l6p+21)
c     s3s2p =store(l6p+22)
      l6d = ld6p+n6p
      l6a = l6d
      m6dk=l6p+n6p
      m6=m6dk+n6dk
      nfl=m6+md6d
      l6=l6d
      return
1000  l6=l6a
      l6d=l6a
      return
      end
c
code for kkfnr
      function kkfnr(vet)
c--fetch the next reflection
c--return values are :
c  -1  last reflection marker found
c   0  next reflection found
c  m6  location of the core buffer
c
c--
      common/lst06/l6,l6a,l6d,ld6p,m6,m6dk,n6dk,md6d,n6d,n6,n6p,
     2 l6rs,l6rk,l6in,l6p,k1,k2,k3
      dimension vet(12)
c--
1000  continue
      j=kkldnr(vet,in)
c--check for the last reflection
      if(j) 2000,1010,1010
1010  continue
      if(in) 1020,2000,1020
c--reflection deleted
1020  continue
      l6=l6+n6dk
      go to 1000
2000  continue
      kkfnr=j
      return
      end
c
code for kkldnr
      function kkldnr(vett,in)
c--load the next reflection from the disc
c
      common/lst06/l6,l6a,l6d,ld6p,m6,m6dk,n6dk,md6d,n6d,n6,n6p,
     2 l6rs,l6rk,l6in,l6p,k1,k2,k3
      common/xfile/ifile,ilist,iend,infle,nwfle,icfle,lid(4)
c
      common /data/ store(5000)
      dimension  istore(5000)
      equivalence(store,istore)
      dimension vet(12),ivet(12) ,vett(12)
      equivalence (vet,ivet)
c--
      kkldnr=0
      call xdwn(l6d,istore(m6dk),n6dk)
c--check for the last reflection marker
      if(istore(m6dk)-iend)1010,1000,1010
1000  continue
      kkldnr=-1
      return
1010  continue
      l6d=l6d+n6dk
c--unpack the values
      in=istore(m6dk  )/k1
      ihkl=istore(m6dk  )-in*k1
      in=in-1
      ih=ihkl/k2
      ikl=ihkl-ih*k2
      ik=ikl/k3
      il=ikl-ik*k3
      ivet(1   )=ih-64
      ivet(2   )=ik-64
      ivet(3   )=il-64
      vet(4)= store(m6dk+1)
      vet(5)= store(m6dk+2)
      vet(6)= store(m6dk+3)
      vet(7)= store(m6dk+4)
      do 100 i=1,12
100   vett(i)=vet(i)
      return
      end
c
code for spb07
      subroutine spb07(iy)
c--rewrite the preamble block for a list 7
c
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,ifper,iprin,iflag
      common/lst07/l7,l7a,l7d,ld7p,m7,m7dk,n7dk,md7d,n7d,n7,n7p,
     2 l7rs,l7rk,l7in,l7p,kk1,kk2,kk3
c
      common/xlimi/nfl,lfl,nl,idummy(3),nfls
      common /data/ store(5000)
      dimension istore(5000)
      equivalence(store,istore)
c--
      in=7
      nfl=nfls
      call srlin(in,li,ld7p,lk,ln,lm)
      n7p=ln
      l7p=nfl
      call srdls(in,l,l7p,lj)
      if (iy.eq.-1) then
                      store(l7p+26)=fosog
                     istore(l7p+27)=ksigma
                    else
                      istore(l7p+25)=iy
                    endif
c--rewrite the preamble block
      call xup(ld7p,istore(nfl),n7p)
      call xdump
      return
      end
c
code for ysfl07
      subroutine ysfl07(nrifl,mmm,mmmz,npseud,iy)
c--load list 7
c
      common/sym/is(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emme
     *          ,s3s2p
      common/rc/p(6),cx(9),nref,nb,rhomax,mm,en,mz,er,th,rhomin
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,ifper,iprin,iflag
      common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,bt,sc,del,ks
      common/lst07/l7,l7a,l7d,ld7p,m7,m7dk,n7dk,md7d,n7d,n7,n7p,
     2 l7rs,l7rk,l7in,l7p,kk1,kk2,kk3
      common/xlimi/ nfl,idummy(5),nfls
      common /data/ store(5000)
      dimension  istore(5000)
      equivalence(store,istore)
c--load the preamble of list 7
      nfl=nfls
      kk3=128
      kk2=128*kk3
      kk1=128*kk2
      inm=7
      call srlin(inm,li,ld7p,lk,ln,lm)
      n7p=ln
      l7p=nfl
      call srdls(inm,l,l7p,lj)
      md7d= store(l7p+5)
      n7dk= store(l7p+6)
      n7d = store(l7p+7)
      n7  = n7d
      nrifl=n7d
      ihx(1)=store(l7p+10)
      ihx(2)=store(l7p+11)
      ihx(3)=store(l7p+12)
      jpart =store(l7p+15)
      knw   =store(l7p+16)
      bt    =store(l7p+17)
      sc    =store(l7p+18)
      mm    =store(l7p+19)
      mz    =store(l7p+20)
      mmm=mm
      mmmz=mz
      s3s2  =store(l7p+21)
      s3s2p =store(l7p+22)
      jtran =int(store(l7p+23))
      npseud=int(store(l7p+24))
      iy    =istore(l7p+25)
      fosog =    store(l7p+26)
      ksigma=istore(l7p+27)
      l7d   =ld7p+n7p
      m7dk=l7p+n7p
      m7=m7dk+n7dk
      nfl=m7+md7d
      l7=l7d
      return
      end
c
code for snr07
      subroutine snr07(vett)
c--read the next reflections
c
c     common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,nonos,iprin,iflag
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,ifper,iprin,iflag
      common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,bt,sc,del,ks
      common/lst07/l7,l7a,l7d,ld7p,m7,m7dk,n7dk,md7d,n7d,n7,n7p,
     2 l7rs,l7rk,l7in,l7p,kk1,kk2,kk3
      common/xlimi/ nfl,idummy(6)
      common /data/ store(5000)
      dimension  istore(5000)
      equivalence(store,istore)
      dimension vett(9),vet(9),ivet(9)
      equivalence (vet,ivet)
c--
      call xdwn(l7d,istore(m7dk),n7dk)
      l7d=l7d+n7dk
c--unpack the values
      in=istore(m7dk  )/kk1
      ihkl=istore(m7dk  )-in*kk1
      in=in-1
      ih=ihkl/kk2
      ikl=ihkl-ih*kk2
      ik=ikl/kk3
      il=ikl-ik*kk3
      ivet(1   )=ih-64
      ivet(2   )=ik-64
      ivet(3   )=il-64
      vet(4)= store(m7dk+1)
      vet(5)= store(m7dk+2)
      vet(6)= int(store(m7dk+3)/32768)*0.001
      vet(7)= amod(store(m7dk+3),32768.)*0.001
      vet(8)= store(m7dk+4)
      vet(9)= store(m7dk+5)
      continue
      do 2100 i=1,9
2100  vett(i)=vet(i)
      return
      end
c
code for frm19
      subroutine frm19(lpseuv,patom,qatom)
c--form list 19, information for pseudo-symmetry
c
      common/xlimi/nfl,lfl,nl,nflmx,lflmx,nlmx,nfls
      common /data/ store(5000)
      dimension istore(5000),lpseuv(12)
      equivalence(store,istore)
c--
      nfl=nfls
      in=19
      call xcln(in)
      n19p=20
      l=nfl+n19p-1
      do 1000 i=nfl+5,l
1000  store(i)=0.0
      store(nfl+5)=patom
      store(nfl+6)=qatom
      m=nfl+7
      do 2000 i=1,12
      store(m)=lpseuv(i)
2000  m=m+1
      call sfrml(in,n19p)
      return
      end
c
code for sfl19
      subroutine sfl19(lpseuv,patom,qatom)
c--read absolute list 19  (information for pseudo-symmetry)
c
      common/xlimi/nfl,lfl,nl,nflmx,lflmx,nlmx,nfls
      common/data/store(5000)
      dimension  istore(5000),lpseuv(12)
      equivalence (istore,store)
c--
      nfl=nfls
      in=19
      call srlin(in,lsn,li,lj,lk,ll)
      if(li.le.0) return
      call sldl(in,ly,li,lz)
      l19d=nfl
      patom=store(l19d+5)
      qatom=store(l19d+6)
      m=l19d+7
      do 2000 i=1,12
      lpseuv(i)=store(m)
2000  m=m+1
      return
      end
c
code for frmxx
      subroutine frmxx(ixx,iln,nxx,nxxa,nxxd,nxxe,icod,ivet)
c--form list xx (relationships)
c
c  ixx =  0  rewrite completely the list number iln
c      = -1  rewrite the preamble of the list number iln
c  iln =  list number
c          8   positive triplets
c          9   psi zero
c         10   negative triplets
c         11   enantiomorphous triplets
c         24   psi-e triplets
c         20   negative quartets
c         21   enantiomorphous quartets
c         26   one phase seminvariants
c         27   two phases seminvariants
c  nxx =  number of relationships to be stored on disc
c  nxxa=  number of relationships to be regarded
c         ( usually  nxx = nxxa  except positive triplets for p10)
c  nxxd=  value to be stored on the preamble
c  nxxe=  value to be stored on the preamble
c  icod=  value to be stored on the preamble
c  ivet=  array containing the relationships
c
      common/unit/lxn,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/xlimi/nfl,lfl,nl,idummy(3),nfls
      common /data/ store(5000)
      dimension istore(5000)
      equivalence(store,istore)
      dimension ivet(60000)
c--
      if(iln.gt.31.or.iln.lt.1) goto 1
c           1  2  3  4  5  6  7  8  9 10
c          11 12 13 14 15 16 17 18 19 20
c          21 22 23 24 25 26 27
      goto( 1, 1, 1, 1, 1, 1, 1, 8, 9, 8,
     *      8, 8, 1, 1, 1, 1, 1, 1, 1,20,
     *     20, 1, 1, 8, 1,26, 8, 1, 1, 1 ),iln
1     write(lo,1001) iln
1001  format(///,i7,25h is not a valid list type)
      stop  1111
8     mdxx=3
      mdxxc=3
      goto 1000
9     mdxx=2
      mdxxc=3
      goto 1000
20    mdxx=3
      mdxxc=7
      goto 1000
26    mdxx=1
      mdxxc=1
1000  nfl=nfls
      call xcln(iln)
      nxxp=19
      l=nfl+nxxp-1
      do 1010 i=nfl+5,l
1010  store(i)=0.0
      store(nfl+5)=mdxx
      store(nfl+6)=mdxxc
      store(nfl+7)=nxxp
      store(nfl+8)=nxx
      store(nfl+9)=nxxa
      store(nfl+10)=nxxd
      store(nfl+11)=nxxe
      store(nfl+12)=icod
      ln=nxxp+(nxx+1)*mdxx
      call sowl(ln,iln,lsn,ldxxp,lk,lm,lj)
      store(nfl+2)=lsn
      call xup(ldxxp,istore,nxxp)
      llw=ldxxp+ln-1
      call swlin(iln,lsn,ldxxp,llw,nxxp,ln)
      if(ixx.lt.0) return
      lxx=ldxxp+nxxp
      lxxdk=nfl+nxxp
      nfl=lxxdk+mdxx
      l=1
      do 2000 i=1,nxx
      m=l
      mxxdk=lxxdk
      do 2100 j=1,mdxx
      istore(mxxdk)=ivet(m)
      m=m+1
2100  mxxdk=mxxdk+1
      call xup(lxx,istore(lxxdk),mdxx)
      lxx=lxx+mdxx
      l=l+mdxxc
2000  continue
      call xdump
      return
      end
c
code for sflxx
      subroutine sflxx(ixx,iln,nxx,nxxa,nxxd,nxxe,icod,ivet)
c--load  list xx  (relationships)
c  ixx =  0  load completely the list number iln
c      = -1  load the preamble of the list number iln
c
      common/unit/lxn,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/xlimi/nfl,lfl,idummy(4),nfls
      common/data/store(5000)
      dimension  istore(5000)
      equivalence (istore,store)
      dimension ivet(60000)
c--
      nfl=nfls
      call srlin(iln,li,ldxxp,lk,ln,lm)
      nxxp=ln
      call srdls(iln,l,nfl,lj)
      mdxx= store(nfl+5)
      mdxxc=store(nfl+6)
      nxxp= store(nfl+7)
      nxx = store(nfl+8)
      nxxa= store(nfl+9)
      nxxd= store(nfl+10)
      nxxe= store(nfl+11)
      icod= store(nfl+12)
      if(ixx.lt.0) return
      lxx  =ldxxp+nxxp
      lxxdk=nfl+nxxp
      nfl=lxxdk+mdxx
      l=1
      do 2000 i=1,nxx
      call xdwn(lxx,istore(lxxdk),mdxx)
      lxx=lxx+mdxx
      m=l
      mxxdk=lxxdk
      do 2100 j=1,mdxx
      ivet(m)=istore(mxxdk)
      m=m+1
2100  mxxdk=mxxdk+1
      l=l+mdxxc
2000  continue
      return
      end
c
code for nfrm16
      subroutine nfrm16(nset)
c--form an empty list 16, set(s) of phases
c
      common /param/ numb,dum(10)
      common/lst016/l16,ld16p,m16,m16d,md16d,n16,n16p,l16p
     1 ,l16a,l16k,n16k,dumm
      common/xlimi/nfl,lfl,nl,idummy(3),nfls
      common /data/ store(5000)
      dimension istore(5000)
      equivalence(store,istore)
c
      nfl=nfls
      in=16
      call xcln(in)
      l16p=nfl
      md16d=11
      m16d=1
      n16r=15
      n16p=n16r+nset*2
      lj=nfl+n16p-1
      do 1000 i=nfl+5,lj
1000  store(i)=0.0
      store(nfl+5)= md16d
      store(nfl+6)= m16d
      store(nfl+7)= numb
      store(nfl+8)= n16r
      store(nfl+9)= n16p
      store(nfl+10)=nset
      m=n16r+nfl
      do 1010 i=1,nset
      store(m)=0.0
1010  m=m+1
      do 1020 i=1,nset
      istore(m)=0
1020  m=m+1
      n16k=numb*m16d+md16d
      ln=n16p+n16k*nset
      call sowl(ln,in,lsn,ld16p,lk,lm,lj)
      store(nfl+2)=lsn
      call xup(ld16p,istore(l16p),n16p)
      llw=ld16p+ln-1
      call swlin(16,lsn,ld16p,llw,n16p,ln)
      l16=ld16p+n16p
      l16a=nfl+n16p
      l16k=l16a+md16d
      l16b=l16k+numb
      l16c=l16b+numb
      do 3000 k=1,nset
      m16k=l16k
      m16b=l16b
      m16c=l16c
      do 2000 i=1,numb
      istore(m16k  )=0
      m16k=m16k+1
      m16b=m16b+1
      m16c=m16c+1
2000  continue
      call xup(l16,istore(l16a),n16k)
      l16=l16+n16k
3000  continue
      call xdump
      return
      end
c
code for ysfl16
      subroutine ysfl16(cfom,ipos,nset)
c--sir-call for loading list 16 (set of phases)
c
      common/xlimi/ nfl,idummy(5),nfls
      dimension cfom(302),ipos(302)
c--
      nfl=nfls
      call sfl16(cfom,ipos,nset)
      return
      end
c
code for sfl16
      subroutine sfl16(cfom,ipos,nset)
c--load list 16 (set of phases)
c
      common/lst016/l16,ld16p,m16,m16d,md16d,n16,n16p,l16p
     1 ,l16a,l16k,n16k,numb
      common/xlimi/ nfl,idummy(5),nfls
      common /data/ store(5000)
      dimension  istore(5000)
      equivalence(store,istore)
      dimension cfom(302),ipos(302)
c--load the preamble of list 16
      inm=16
      call srlin(inm,li,ld16p,lk,ln,lm)
      n16p=ln
      l16p=nfl
      call srdls(inm,l,l16p,lj)
      md16d= store(l16p+5)
      m16d = store(l16p+6)
      numb = store(l16p+7)
      n16r = store(l16p+8)
      n16p = store(l16p+9)
      nset = store(l16p+10)
      m=n16r+l16p
      do 1010 i=1,nset
      cfom(i)=store(m)
1010  m=m+1
      do 1020 i=1,nset
      ipos(i)=istore(m)
1020  m=m+1
      n16k=numb*m16d+md16d
      l16    =ld16p+n16p
      l16a=l16p+n16p
      l16k=l16a+md16d
      return
      end
c
code for snr16
      subroutine snr16(it,fig,ww,iph)
c--read the required it-th set of phases
c
      common/lst016/l16,ld16p,m16,m16d,md16d,n16,n16p,l16p
     1 ,l16a,l16k,n16k,numb
      common/xlimi/ nfl,idummy(6)
      common /data/ store(5000)
      dimension  istore(5000)
      equivalence(store,istore)
      dimension ww(numb),iph(numb),fig(md16d)
c--
      l16d=l16+(it-1)*n16k
      call xdwn(l16d,istore(l16a),n16k)
c--unpack the values
      m=l16a
      do 1000 i=1,md16d
      fig(i)=store(m)
1000  m=m+1
      m16k=l16k
      do 2000 i=1,numb
      idum=istore(m16k)/512
      idum1=istore(m16k)-idum*512
      ww(i)=float(idum)/1000000.
      iph(i)=idum1
      m16k=m16k+1
2000  continue
      return
      end
c
code for snw16
      subroutine snw16(it,fig,ww,iph)
c--write the it-th set of phases
c
      common/lst016/l16,ld16p,m16,m16d,md16d,n16,n16p,l16p
     1 ,l16a,l16k,n16k,numb
      common/xlimi/ nfl,idummy(6)
      common /data/ store(5000)
      dimension  istore(5000)
      equivalence(store,istore)
      dimension ww(numb),iph(numb),fig(md16d)
c--
      l16d=l16+(it-1)*n16k
c-- pack the values
      m=l16a
      do 1000 i=1,md16d
      store(m)=fig(i)
1000  m=m+1
      m16k=l16k
      do 2000 i=1,numb
      if(ww(i).gt.1.0) ww(i)=1.0
      dum =ww(i)*1000000
      idum=nint(dum)
      istore(m16k  )=iph(i)+idum*512
      m16k=m16k+1
2000  continue
      call xup(l16d,istore(l16a),n16k)
      call xdump
      return
      end
c
code for ysup16
      subroutine ysup16(cfom,ipos,noset)
c--sir-call to update the preamble block of list 16
c
      common/xlimi/nfl,lfl,idummy(4),nfls
      dimension cfom(302),ipos(302)
c--
      nfl=nfls
      call sup16(cfom,ipos,noset)
      return
      end
c
code for sup16
      subroutine sup16(cfom,ipos,noset)
c--update the preamble block of list 16
c
      common/lst016/l16,ld16p,m16,m16d,md16d,n16,n16p,l16p
     1 ,l16a,l16k,n16k,numb
      common/xlimi/nfl,lfl,idummy(4),nfls
      common/data/store(5000)
      dimension  istore(5000)
      equivalence(istore,store)
      dimension cfom(302),ipos(302)
c--
      l16p=nfl
      call srdls(16,li,l16p,l)
      n16r = store(l16p+8)
      n16p = store(l16p+9)
      nset = store(l16p+10)
      if (noset.le.nset) then
                           nset=noset
                           store(l16p+10) = nset
                         endif
      m=n16r+nfl
      do 1010 i=1,nset
      store(m)=cfom(i)
1010  m=m+1
      do 1020 i=1,nset
      istore(m)=ipos(i)
1020  m=m+1
      l=n16p
      call srlin(16,lsn,ln,llw,l,ll)
      call xup(ln,istore(l16p),n16p)
      call xdump
      return
      end
c
code for ysfp07
      subroutine ysfp07(nrifl,npseud,iy)
c--form preamble of the  list 7
c
      common/sym/is(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emme
     *          ,s3s2p
      common/rc/p(6),cx(9),nref,nb,rhomax,mm,en,mz,er,th,rhomin
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,nonos,iprin,iflag
      common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,bt,sc,del,ks
      common/lst07/l7,l7a,l7d,ld7p,m7,m7dk,n7dk,md7d,n7d,n7,n7p,
     2 l7rs,l7rk,l7in,l7p,kk1,kk2,kk3
c
      common/xlimi/nfl,lfl,nl,idummy(3),nfls
      common /xfile/ ifile,ilist,iend,infle,nwfle,icfle,lid(4)
      common /data/ store(5000)
      dimension istore(5000)
      equivalence(store,istore)
      kk3=128
      kk2=128*kk3
      kk1=128*kk2
      nfl=nfls
      in=7
      call xcln(in)
      l7p=nfl
      md7d=7
      n7dk=6
      nref=nrifl
      n7p=30
      lj=nfl+n7p-1
      do 1000 i=nfl+5,lj
1000  store(i)=0.0
      store(nfl+5)= md7d
      store(nfl+6)= n7dk
      store(nfl+7)= nrifl
      store(nfl+9)= n7p
      store(nfl+10)=ihx(1)
      store(nfl+11)=ihx(2)
      store(nfl+12)=ihx(3)
      store(nfl+15)=float(jpart)
      store(nfl+16)=float(knw)
      store(nfl+17)=bt
      store(nfl+18)=sc
      store(l7p+19)=mm
      store(l7p+20)=mz
      store(l7p+21)=s3s2
      store(l7p+22)=s3s2p
      store(l7p+23)=jtran
      store(l7p+24)=float(npseud)
      istore(l7p+25)=iy
      store(l7p+26)=fosog
      istore(l7p+27)=ksigma
      ln=n7p+(nref+1)*n7dk
      call sowl(ln,in,lsn,ld7p,lk,lm,lj)
      store(nfl+2)=lsn
      call xup(ld7p,istore(l7p),n7p)
      llw=ld7p+ln-1
      call swlin(7,lsn,ld7p,llw,n7p,ln)
      call xdump
      return
      end
code for xslw07
      subroutine xslw07(vett)
c--store the last reflection on the disc
c
      common/lst07/l7,l7a,l7d,ld7p,m7,m7dk,n7dk,md7d,n7d,n7,n7p,
     2 l7rs,l7rk,l7in,l7p,kk1,kk2,kk3
      common /data/ store(5000)
      dimension  istore(5000)
      equivalence(store,istore)
      dimension vet(6),ivet(6),vett(6)
      equivalence (vet,ivet)
c
      do 100 i=1,6
  100 vet(i)=vett(i)
      istore(m7dk  )=ivet(1)
       store(m7dk+1)= vet(2)
       store(m7dk+2)= vet(3)
       store(m7dk+3)= vet(4)
      istore(m7dk+4)=ivet(5)
       store(m7dk+5)= vet(6)
      call xup(l7,istore(m7dk),n7dk)
      l7=l7+n7dk
      return
      end
code for frm15
      subroutine frm15(nats,numset,interp)
c--form list 15, coordinates of the fragments
c
c   nats = number of coordinates
c   numset = number of set
c   interp = 0 if no interpretation of peaks has been performed
c          = 1 if    interpretation of peaks has been performed
c   x	   = x y z int occ
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,ifper,iprin,iflag
      common /atoms/ x(5,200),icvet(200),ngp,ninf(10),nag(10)
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(200),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common/xchar/id,ie,ib,ic,ia,ih
     1 ,numb(10),iplus, inus,ipoint
      common/xlimi/nfl,lfl,nl,idummy(3),nfls
      common /data/ store(5000)
      common /temp/ conn(9800)
      dimension istore(5000)
      equivalence(store,istore)
c--
      nfl=nfls
      call xcln(15)
Corig md15=8
      md15=9
      mm=15
c
       store(nfl+ 5) = mm
       store(nfl+ 6) = md15
       store(nfl+ 7) = nats
       store(nfl+ 8) = numset
       store(nfl+ 9) = interp
       store(nfl+10) = errem
      istore(nfl+11) = maxcyc
      istore(nfl+12) = jrest
       store(nfl+13) = biso
       store(nfl+14) = oscale
      l15=nfl+mm
      m15=l15
      do 2000 i=1,nats
      icv=icvet(i)
      kfrag=0
      if (icv.lt.0) then
                      icv=iabs(icv)
                      kfrag=0
                    else
                      kfrag=mod(icv,100)
                    endif
      iz=icv/100
      istore(m15  )=iz
      istore(m15+1)=i
      istore(m15+2)=kfrag
       store(m15+3)=x(1,i)
       store(m15+4)=x(2,i)
       store(m15+5)=x(3,i)
       store(m15+6)=x(4,i)
       store(m15+7)=x(5,i)
       store(m15+8)=bfac(i)
      m15=m15+md15
 2000 continue
c
c-- connectivity
c
      if (interp.eq.1) then
                         nconn=conn(1)
                         store(m15)=-1.0
                         do 2100 i=1,nconn*2+1
                         store(m15)=conn(i)
                         m15=m15+1
 2100                    continue
                       endif
c
      n=5000
c
      iln=15
      call sfrml(iln,n)
      call xdump
      return
      end
c
code for sfl15
      subroutine sfl15(nats,idisp,numset,interp)
c--read absolute list 15  (coordinates of the fragments)
c
c   nats = number of coordinates
c   numset = number of set
c   interp = 0 if no interpretation of peaks has been performed
c          = 1 if    interpretation of peaks has been performed
c  idisp = starting position in x and nz array
c
c
c
c
      common/sf/al(4,8),bs(4,8),cl(8),nnw(8),nno(8),nk,nat,f(9),nalf(8)
c
c
c
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common /atoms/ x(5,200),icvet(200),ngp,ninf(10),nag(10)
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(200),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common/xlimi/nfl,lfl,nl,idummy(3),nfls
      common/data/store(5000)
      common /temp/ conn(9800)
      dimension  istore(5000)
      equivalence (istore,store)
c--
      call srlin(15,lsn,li,lj,lk,ll)
      nfl=nfls
      call sldl(15,li,l15d,lj)
      mm     =  store(l15d+ 5)
      md15   =  store(l15d+ 6)
      nats   =  store(l15d+ 7)
      numset =  store(l15d+ 8)
      interp =  store(l15d+ 9)
      errem  =  store(l15d+10)
      maxcyc = istore(l15d+11)
      jrest  = istore(l15d+12)
      biso   =  store(l15d+13)
      oscale =  store(l15d+14)
      l15=l15d+mm
      m15=l15
      if (idisp.lt.1.or.idisp.gt.200) idisp=1
      k=idisp
      do 2000 i=1,nats
      iz     =istore(m15  )
      kfrag  =istore(m15+2)
      icv=iz*100+kfrag
      if (kfrag.eq.0.and.iz.gt.0) icv=-icv
      icvet(k)=icv
      x(1,k) = store(m15+3)
      x(2,k) = store(m15+4)
      x(3,k) = store(m15+5)
      x(4,k) = store(m15+6)
      x(5,k) = store(m15+7)
      bfac(k)= store(m15+8)
      k=k+1
      m15=m15+md15
2000  continue
c
c-- connectivity
c
      if (interp.eq.1) then
                         nconn=store(m15)
                         do 2100 i=1,nconn*2+1
                         conn(i)=store(m15)
                         m15=m15+1
 2100                    continue
                       endif
c
      return
      end
c
code for cp1530
      subroutine cp1530
c
c--save list 15 in list 30
c
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common /atoms/ x(5,200),icvet(200),ngp,ninf(10),nag(10)
      common/xlimi/nfl,lfl,nl,idummy(3),nfls
      common/data/store(5000)
      dimension  istore(5000)
      equivalence (istore,store)
c--
      nfl=nfls
      call srlin(15,lsn,li,lj,lk,ll)
      call sldl(15,li,l15d,lj)
      mm  =store(l15d+5)
      md15=store(l15d+6)
      nats=store(l15d+7)
      numset=store(l15d+8)
      interp=store(l15d+9)
c
      n=5000
      iln=30
      store(l15d+1) = iln
c
      call sfrml(iln,n)
      call xdump
      return
      end
c
code for cp3015
      subroutine cp3015
c
c--restore list 30 in list 15
c
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common /atoms/ x(5,200),icvet(200),ngp,ninf(10),nag(10)
      common/xlimi/nfl,lfl,nl,idummy(3),nfls
      common/data/store(5000)
      dimension  istore(5000)
      equivalence (istore,store)
c--
      nfl=nfls
      call srlin(30,lsn,li,lj,lk,ll)
      call sldl(30,li,l15d,lj)
      mm  =store(l15d+5)
      md15=store(l15d+6)
      nats=store(l15d+7)
      numset=store(l15d+8)
      interp=store(l15d+9)
c
      n=5000
      iln=15
      store(l15d+1) = iln
c
      call sfrml(iln,n)
      call xdump
      return
      end
c
code for sfl30
      subroutine sfl30(nats,idisp,numset,interp)
c--read absolute list 30  (copy of list 15)
c
c   nats = number of coordinates
c   numset = number of set
c   interp = 0 if no interpretation of peaks has been performed
c          = 1 if    interpretation of peaks has been performed
c  idisp = starting position in x and nz array
c
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common /atomo/ x(5,200),icvet(200),dold(400)
      common/xlimi/nfl,lfl,nl,idummy(3),nfls
      common/data/store(5000)
      dimension  istore(5000)
      equivalence (istore,store)
c--
***** nfls=nfl
      call srlin(30,lsn,li,lj,lk,ll)
      nfl=nfls
      call sldl(30,li,l15d,lj)
      mm  =store(l15d+5)
      md15=store(l15d+6)
      nats=store(l15d+7)
      numset=store(l15d+8)
      interp=store(l15d+9)
      l15=l15d+mm
      m15=l15
      if (idisp.lt.1.or.idisp.gt.200) idisp=1
      k=idisp
      do 2000 i=1,nats
      iz     =istore(m15  )
      kfrag  =istore(m15+2)
      icv=iz*100+kfrag
      if (kfrag.eq.0.and.iz.gt.0) icv=-icv
      icvet(k)=icv
      x(1,k) = store(m15+3)
      x(2,k) = store(m15+4)
      x(3,k) = store(m15+5)
      x(4,k) = store(m15+6)
      x(5,k) = store(m15+7)
      k=k+1
      m15=m15+md15
2000  continue
      return
      end
