c-- sir code for sir92                          Release 93.02
      program sir92 
      character file*80,line*80
      character fname(9)*80,ext(9)*4
c-- file names and extensions
      common/dotdat/ fname,ext
c-- input/output units, title
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
c-- trigonometric tables and constants
      common/trig/sint(450),pi,twopi,dtor,rtod
c-- implementation specific flags
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
c-- direct access file related commons
      common/xdisu/ncdfu ,ndfle,irecx
      common /xfile/ ifile,jjlist,jjend,infle,nwfle,icfle,lid(4)
      common /xfili/ lfirst,nwblo,lindex(240)
c-- scratch file reflexion arrays
      common /buffer/ vet(6,85),nrpb,idumb(4)
c-- user requests
      common / ureq1/ jpatt,jpunt(501),ksacc,jseteq,jumpp,jmpsie,nsec
c-- coordinats 
      common /atoms/ x(5,200),nz(200),ngp,ninf(10),nag(10)
      common /atomo/ xtot(1600)
c-- graphics
      common/screen/ kscreen,iy,ivd,kscrx,kscry,jscreen,kprog,ifMouse
c
c--
      ier = 0
      call pc386(ier)
      if (ier.lt.0) go to 1000
c     set flag for caos environment
      jcaos=0
      ncdfu=jdir
c     set flag for direct execution
      iexec=-1
c
c-- set up the default names for work files
c
      do 10 i=1,4
      file=fname(i)(1:30)//ext(i)
      call xcmprp(file,lfile)
      fname(i)=file
   10 continue
c
c-- define the number of reflections per block in scratch file
c--   nrpb = (number of words in block) / 6
c
      nrpb=knwr/6
   50 call spoolr(jcaos,line,newf,iexec,jfour,ier)
      if (ier.lt.0) go to 1000
c
c-- initialize the graphics
c
      call scr1
c
      call sircom(newf,iexec,jfour,ier)
      if (ier.lt.0) go to 1000
      if (iexec.ge.0) go to 50
 1000 if (ier.lt.0) then
                      write(line,2000)
                    else
                      write(line,3000)
                    endif
c
      lline=20
      if(ier.ne.-2) call scrend(line,lline)
      if (jcaos.eq.0) close (jdir)
      write(lo,4000) line(1:lline)
c
 2000 format(' SIR92 ends in error')
 3000 format(' SIR92 ends ok      ')
 4000 format(//,1h ,a)
      stop
      end
c-----------------------------------------------------------------------
      subroutine spoolr(jcaos,line,newf,iexec,jfour,ier)
      character line*80,hklf*80,releas*5,com4*4
      character beg,commen,allcom(25)*14,dire*80,defa*7
      character blank,digit*12,card(100)*80,ffile*80
      common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /xfile/ ifile,jjlist,jjend,infle,nwfle,icfle,lid(4)
      common /xfili/ lfirst,nwblo,lindex(240)
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      character*8 itldef
      character fname(9)*80,ext(9)*4
      common/dotdat/ fname,ext
      common /chara/ blank,digit,card,ffile
      common /charas/ beg,commen,allcom
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,ifper,iprin,iflag
      common / ureq1/ jpatt,jpunt(501),ksacc,jseteq,jumpp,jmpsie,nsec
      common /genob/ irho
      common /atoms/ x(5,200),nz(200),ngp,ninf(10),nag(10)
      common /screen/ kscreen,iy,ivd,kscrx,kscry,jscreen,kprog,ifMouse
      dimension vet(40),ivet(40)
      data itldef /' sir 92 '/
c
      if (iexec.lt.0) then
                        pi=4.0*atan(1.0)
                        twopi=2.0*pi
                        rtod=180.0/pi
                        dtor=1.0/rtod
c     set up sin/cos table
                        do 50 i=1,450
                        sint(i)=sin(dtor*float(i-1))
   50                   continue
                        allcom(15)(1:1)=beg
                        do 100 i=1,19,2
  100                   read(itldef,'(2a4)') itle(i),itle(i+1)
                        jfour=0
                      endif
      ifper=0
      irefl=0
      kcont=0
      ier=0
      init=0
      nallc=25
      ipcom=0
      icomo=2
      ipdir=0
      nerr=0
      do 120 i=1,maxcom
      do 120 j=1,2
  120 icomq(i,j)=0
      ifli=0
c
      if (jcaos.eq.1) ifli=1
c
c-- read cards
c
  130 format(a)
      if (iexec.gt.0) write(lo,135) beg,beg,beg
  135 format(//,' Please enter commands and directives ( ',a1,a1,' to go
     *, ',a1,'end to stop )')
  140 if (ifli.eq.0) read(ln,130,end=2000) line
      ifli=0
      call shift(line,nchar)
      if (nchar.le.0.or.line(1:1).eq.commen) go to 140
c
c-- if first character is equal to '%' it is a command 
c
      if (line(1:1).eq.beg) then
c
c-- check if the command is an "exec" one
c
            if (line(2:2).eq.beg) then
                                    iexec=iexec+1
c                                   return
                                    go to 165
                                  endif
CCCCCCCCCif (line(2:2).ne.blank) then
c
c-- verify if the command is allowed
c
         icom=0
         com4=line(2:5)
         call lcase(com4)
         do 150 i=1,nallc
         if (com4.eq.allcom(i)(1:4)) icom=i
  150    continue
         jcom=0
c
c-- if %PATTERSON next command must be %END
c
         if (icomo.eq.16) icom=7
c
         if (icom.eq.0) then
                           go to 3000
                         else
                           if (icom.eq.25) then
c
c--       the command is  %window
c
                                    call cutst(line,lenp,dire,lend)
                                    iopt=0
                                    call getnum(line,vet,ivet,iv,iopt)
                                    if (iv.eq.2) then
                                        kscrx=max0(639,ivet(1))
                                        kscry=max0(479,ivet(2))
                                    endif
                                            jcom=1
                                            kscreen=1
                                          endif
                           if (icom.eq.24) then
c
c--       the command is  %nowindow
c
                                            jcom=1
                                            kscreen=0
                                          endif
                           if (icom.eq.8) then
c
c--       the command is  %continue
c
                                            jcom=1
                                            icomo=icomo+1
                                            if (icomo.eq.2) icomo=3
                                            if (icomo.eq.24) icomo=1
                                            do 160 ii=icomo,7
                                            if (ii.eq.2) go to 160
                                            ipcom=ipcom+1
                                            if (ipcom.gt.maxcom) 
     *                                      go to 6000
                                            icomq(ipcom,1)=ii
  160                                       continue            
                                          endif
                           if (icom.eq.9) then
c
c--       the command is  %job
c
                                         jcom=1
                                         call cutst(line,lenp,dire,lend)
                                         read(line,'(20a4)') itle
                                       endif
                           if (icom.eq.10) then
c
c--       the command is  %file
c
                                         jcom=1
      call cutst(line,lenp,dire,lend)
      if (lenp.le.0) go to 1000
      call cutst(line,lenp,dire,lend)
      fname(1)=dire
      if (lenp.gt.0) then
                       call cutst(line,lenp,dire,lend)
                       fname(3)=dire
                     endif
                                       endif
                           if (icom.eq.22) then
c
c--       the command is  %structure
c
                                         jcom=1
      call cutst(line,lenp,dire,lend)
      if (lenp.le.0) go to 1000
      call cutst(line,lenp,dire,lend)
      fname(1)=dire(1:lend)//ext(1)
      fname(2)=dire(1:lend)//ext(2)
      fname(3)=dire(1:lend)//ext(3)
      fname(4)=dire(1:lend)//ext(4)
                                       endif
                           if (icom.eq.12) then
c
c--       the command is %initialize
c
                                            jcom=1
                                            init=1
                                           endif
                           if (jcom.eq.0) then
                                            ipcom=ipcom+1
                                            if (ipcom.gt.200) go to 6000
                                            icomq(ipcom,1)=icom
                                            icomo=icom
                                          endif
                         endif
CCCCCCCCCC               endif
          else
c
c-- it is a directive
c
            if (ipcom.eq.0) go to 4000
            ipdir=ipdir+1
            if (ipdir.gt.100) go to 5000
            card(ipdir)=line
            com4=line(1:4)
            call lcase(com4)
            icomq(ipcom,2)=icomq(ipcom,2)+1
            if (com4.eq.'scha'.or.
     *          com4.eq.'mold'.or.
     *          com4.eq.'molp') then
                                  call cutst(line,lenp,dire,lend)
                                  if (lenp.gt.0) fname(4)=line
                                endif
            if (com4.eq.'refl') then
                        call cutst(line,lenp,dire,lend)
                        irefl=1
                        com4=line(1:4)
                        call lcase(com4)
                        if (com4.eq.'foll') then
                            jfile=ln
                            hklf=' '
                            hklf(1:20) ='card reader         '
                          else 
                            hklf=line
                          endif
                        endif
            if (com4.eq.'cont') kcont=1
          endif
      if (icom.ne.7.and.icom.ne.8) go to 140
      if (nerr.ne.0) go to 9000
  165 if (iexec.gt.0) return
      iexec=iexec+1
      if (jcaos.eq.0) then
c-- initialize history array
      if (kenvir.eq.0) then
                         do 170 i=1,99
  170                    kstory(i)=0
                       endif
c-- set up internal structures
      call star9
      itipe=0
      if (kopen(jdir,fname(1),nlen,itipe,ierr).ge.0) go to 200
      write(lo,190) ierr,fname(1)
  190 format(' error ',i5,'  opening file ',a)
      ier=-2
      return
  200 continue
      call xdwn(lfirst,lindex,10)
      newf=0
      if (init.eq.1) lindex(8)=ifile+1
      if (lindex(8).ne.ifile) then
                                call setfi
                                newf=1
                              endif
      call xlc
      call xcsae
                         endif
c--
      write(lo,215) itle
  215 format(1h ,120('*'),/,20x,20a4,//)
      call wrhead
      write(lo,220)
  220 format(' Used commands & directives:',/)
      jj=0
      do 240 i=1,ipcom
         do 225 j=1,80
  225    line(j:j)=blank
         j=icomq(i,1)
         if (j.eq.6) jfour=1
         write(line(1:26),'(11x,a1,a14)') beg,allcom(j)
         if (icomq(i,2).eq.0) then
                                defa='default'
                                if (icomq(i,1).eq.7) defa='       '
                                write(line(28:34),'(a7)') defa
                                write(lo,'(/,a)') line
                              else
                                do 230 j=1,icomq(i,2)
                                 jj=jj+1
                                 if (j.eq.1) then
                                 write(lo,'(/,a)') line(1:27)//card(jj)
                                             else
                                 write(lo,'(27x,a)') card(jj)
                                             endif
  230                           continue
                              endif
  240 continue
      write(lo,290) ln,lo,jdir,fname(1),iscra,jrel
      if (irefl.ne.0) write(lo,300) jfile,hklf
      if (kcont.eq.1)  then
                         itype=2
                         iform=1
                         jop=jopen(kform,ffile,nlen,itype,iform,ierr)
                         if (jop.lt.0) then
                                         write(lo,270) ierr,ffile
                                         ier=-2
                                       else
                         read(kform,280,iostat=ierr,err=7000) releas
                         write(lo,310) kform,ffile,releas
                         close (kform)
                         if (releas.ne.'92.11') then 
                                                  ier=-2
                                                  write(lo,311) '92.11'
                                                endif
                                       endif
                       endif
      if (jfour.eq.1)  write(lo,320) jhost,fname(3),jgrap,fname(4),ifour
  270 format(' *** error ***  open error, code =',i5,' file is ',a)
  280 format(a5)
  290 format(//,   ' Files used in sir:',//,
     *     '  Channel                                  Name',/,
     1            i6,'    card reader',/,
     2            i6,'    line printer',/,
     3            i6,'    direct access structure file     ',a,/,
     4            i6,'    direct access scratch file',/,
     5            i6,'    sequential scratch file ')
  300 format(     i6,'    reflection input file            ',a)
  310 format(     i6,'    scattering factors file          ',a,
     1     /, 6x,    '    ( Release : ',a5,' )')
  311 format(/,6x,'    *** error ***  Release should be ',a5,' !!',/)
  320 format(     i6,'    fourier peaks file               ',a,/,
     *            i6,'    peaks file to be plotted         ',a,/,
     *            i6,'    sequential scratch file ',//)
      write(lo,'(//)')
      if (newf.eq.1) then
                       write(lo,330)
                     else
                       write(lo,340)
                       call summar
                     endif
  330 format(6x,'Direct access structure file has been initialized'//)
  340 format(6x,'Direct access structure file actually contains:'/)
      return
 1000 continue
      write(lo,1010) 
 1010 format(' No structure name specified ')
      go to 9000
 2000 continue
      write(lo,2010)
 2010 format(' no   %end or %continue   command specified')
      go to 9000
 3000 continue
      write(lo,3010) line(1:nchar)
 3010 format(' error in command ',a)
      go to 9000
 4000 write(lo,4100) line(1:nchar)
 4100 format(' no command specified for directive ',a)
      go to 9000
 5000 write(lo,5100)
 5100 format(' more than 100 directives used ',/,
     *       ' check for missing  %end or %continue')
      go to 9000
 6000 write(lo,6100) maxcom
 6100 format(' more than ',i5,' commands used ',/,
     *       ' check input file or submit two jobs ')
      go to 9000
 7000 nrec=1
      write(lo,7100) ierr,nrec,ffile
 7100 format(' error ',i5,' reading record no. ',i3,' in file ',a)
 9000 ier=-2
      return
      end
c-----------------------------------------------------------------------
      subroutine sircom(newf,iexec,jfour,ier)
c-- main subroutine to handle sir commands
      character beg,commen,allcom(25)*14
      common /charas/ beg,commen,allcom
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      character fname(9)*80,ext(9)*4
      common/dotdat/ fname,ext
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
      common /xlimi/ idummy(6),nfls
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,ifper,iprin,iflag
      common / ureq1/ jpatt,jpunt(501),ksacc,jseteq,jumpp,jmpsie,nsec
      common /genob/ irho
c
      ier=0
Corig if (jfour.eq.1)  then
Corig                    itype=0
Corig                    iform=1
Corig                    jop=jopen(jhost,fname(3),nlen,itype,iform,ier)
Corig                    if (jop.lt.0) go to 7000
Corig                  endif
      ipdir =0
      icomat=0
   80 if (ier.lt.0) return
      nfls=1
      nfl=1
      icomat=icomat+1
      j=icomq(icomat,1)
      if (j.ne.0) then
      jj=kstory(20)+1
      kstory(20)=jj
      jj=jj+20
      if (jj.le.99) kstory(jj)=j
c
      if (j.eq. 4) call scrpd
      if (j.eq. 5) call scrfd
      if (j.eq.13) call scrrd
      call scr2
c
      go to (100,200,300,400,500,600,700,800,900,1000,
     *       1100,1200,1300,1400,1500,1600,1700,1800,
     *       1900,2000,2100,2200,2300,2400,2500),j
c-- normal     routine
  100 continue
      call normal(ier)
      go to 80
c-- seminvariants routine
  200 continue
      call seminv(ier)
      go to 80
c-- invariants routine
  300 continue
      call invar(ier)
      go to 80
c-- phase   routine
  400 continue
      call contan(ier)
      go to 80
c-- fourier routine
  500 continue
      call fourie(fname(3),ier)
      go to 80
c-- export command
  600 continue
      call export(ier)
      go to 80
c-- end command
  700 continue
      go to 1500
c-- continue command
  800 continue
      ier=-1
      go to 3000
c-- job command
  900 continue
      ier=-1
      go to 3000
c-- file command
 1000 continue
      ier=-1
      go to 3000
c-- dummy  command
 1100 continue
      ier=-1
      go to 3000
c-- initialize
 1200 continue
      ier=-1
      go to 3000
c-- restart command
 1300 continue
      call restar(ier)
      go to 80
c-- history command
 1400 continue
      call befor
      go to 80
 1600 continue
      call patter(ier)
      go to 80
c-- quartets command
 1700 continue
      kkk=0
c     call newqua(kkk,ier)
      go to 80
c-- caos command
 1800 continue
      call caosm(ier)
      go to 80
 1900 continue
      ier=-1
      go to 3000
 2000 continue
      ier=-1
      go to 3000
 2100 continue
      ier=-1
      go to 3000
 2200 continue
      ier=-1
      go to 3000
c-- data       routine
 2300 continue
      call datasir(newf,ier)
      go to 80
c--  nowindow command  
 2400 continue
      ier=-1
      go to 3000
c--  window command  
 2500 continue
      ier=-1
      go to 3000
c-- exec command
 1500 iexec=-1
          endif
      return
 3000 write(lo,3100) j,allcom(j)
 3100 format(' wrong command code = ',i5,' for ',a14,' command')
      return
      end
c-----------------------------------------------------------------------
      subroutine befor
      character cff,beg,commen,allcom(25)*14
      common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common /charas/ beg,commen,allcom
c
      kkff=0     
      write(cff,'(i1)') kkff
      write(lo,100) cff,itle
  100 format(///,a1 ,120('+'),//,
     1 39h SIR92 : History of the structure      ,68x,14hRelease  93.02
     2 ,//,20x,20a4,/,1h ,120('+'),/)
      ifin=kstory(20)-1
      kstory(20)=ifin
      if (ifin.le.0) then
                      write(lo,300)
                     else
                      write(lo,400)
                      do 200 i=1,ifin
                      j=i+20
                      jj=kstory(j)
                      write(lo,500) allcom(jj)
  200                 continue
                     endif
  300 format(/,10x,' The structure has no story',/)
  400 format(/,10x,' List of commands issued in the past',/)
  500 format(11x,a1,a14)
      return
      end

c-----------------------------------------------------------------------
code for cancella
      subroutine cancella(iln)
c
c--clear the entry for a list in the current index table
c--iln = the list type number
c
      common/xfile/ifile,ilist,iend,infle,nwfle,icfle,lid(4)
      common/xfili/lfirst,nwblo,lindex(240)
c
      lista=iln
      mln=lindex(2)
      il =lindex(5)
      if(lista) 2051,2051,2210
 2210 continue
      if(lista-mln) 2220,2220,2051
 2220 continue
      i=lista*il+1
      lindex(i)=0
      i=lindex(6)
      call xup(lindex(3),lindex,i)
      call xdump
 2051 return
      end
c-----------------------------------------------------------------------
      subroutine getnum(linei,vet,ivet,iv,iopt)
      dimension vet(40),ivet(40)
      character blank,digit*12,card(100)*80,ffile*80
      character linei*(*),resto*80,cifre*80
      common /chara/ blank,digit,card,ffile
c
      iv=0
      do 1 i=1,40
    1 vet(i)=0.0
      k=len(linei)
      do 2 i=1,80
    2 resto(i:i)=blank
      do 3 i=1,k
    3 resto(i:i)=linei(i:i)
    5 sum=0.0
      isum=0
      call cutst(resto,ncharl,cifre,nchard)
      if (nchard.le.0) return
      segno=1.0
      isegno=1
      iniz=1
      if (cifre(1:1).eq.digit(12:12)) then
                                       segno=-1.0
                                       isegno=-1
                                       iniz=2
                                     endif
      ipoi=index(cifre(1:nchard),digit(11:11))
      if (ipoi.eq.0) ipoi=nchard+1
      dec=ipoi-1-iniz
      idec=ipoi-1-iniz
      do 10 i=iniz,nchard
      idig=index(digit,cifre(i:i))
      if (idig.ge.1.and.idig.le.11)  then
         if (idig.le.10)  then
                            sum=sum+float(idig-1)*10.0**dec
                            if (idec.ge.0) isum=isum*10+(idig-1)
                            dec=dec-1.0
                            idec=idec-1.0
                          endif
                                     else
                                       iopt=-1
                                       return
                                     endif
   10 continue
      iv=iv+1
      vet(iv)=sum*segno
      ivet(iv)=isum*isegno
      if (ncharl.le.0) then
                         iopt=1
                         return
                       endif
      if (iv.eq.iopt) return
      go to 5
      end
c-----------------------------------------------------------------------
      subroutine shift(string,lenp)
      character string*(*)
      character blank,digit*12,card(100)*80,ffile*80
      common /chara/ blank,digit,card,ffile
c
      k=len(string)
      ifin=1
      do 10 i=1,k
      if (string(i:i).ne.blank) then
                                  iniz=i
                                  go to 20
                                endif
   10 continue
      lenp=-1
      return
   20 do 30 i=k,1,-1
      if (string(i:i).ne.blank) then
                                  ifin=i
                                  go to 40
                                endif
   30 continue
   40 continue
      lenp=ifin-iniz+1
      if (iniz.eq.1) return
      do 50 i=1,lenp
      j=iniz+i-1
   50 string(i:i)=string(j:j)
      if (lenp.eq.k) return
      do 60 i=lenp+1,k
   60 string(i:i)=blank
      return
      end
c-----------------------------------------------------------------------
      subroutine cutst(string,lens,dire,lend)
      character string*(*),dire*(*)
      character blank,digit*12,card(100)*80,ffile*80
      common /chara/ blank,digit,card,ffile
c
      k=len(dire)
      do 5 i=1,k
    5 dire(i:i)=blank
      k=len(string)
      do 10 i=1,k
      if (string(i:i).eq.blank) then
                                  iniz1=i
                                  go to 20
                                endif
   10 continue
   20 continue
      lend=min0(iniz1-1,40)
      do 25 i=1,lend
      dire(i:i)=string(i:i)
   25 string(i:i)=blank
      call shift(string,lens)
      return
      end
c-----------------------------------------------------------------------
      subroutine summar
c
c-- summarize the content of the direct access file
c
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/sym/is(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emme
     *          ,s3s2p
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nat,f(9),nalf(8)
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,ifper,iprin,iflag
      common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,bt,sc,del,ks
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common /xdata/ num(350),dmat(3,500),mat(3,30000),
     * mat1(7,1000),lpseud(12),cfom(302),ipos(302),dumm(60534)
     * ,dummpc(84000)
      integer dmat
c
      call srlin (1,lsn,lixx,ljxx,lkxx,llxx)
      if(lixx.gt.0) then
                      call yfl01
                      write(lo,30)
                    endif
   30 format(32x,' cell parameters ')
      call srlin (2,lsn,lixx,ljxx,lkxx,llxx)
      if(lixx.gt.0) then
                      call yfl02
                      write(lo,50) nsym
   50 format(26x,i6,' symmetry operators ')
                    endif
      call srlin (3,lsn,lixx,ljxx,lkxx,llxx)
      if(lixx.gt.0) then
                      call yfl03
                      write(lo,96) nk
                    endif
   96 format(26x,i6,' atomic species')
      call srlin (7,lsn,lixx,ljxx,lkxx,llxx)
      if(lixx.gt.0) then
                      call ysfl07(nrifl,mmm,mmmz,npseud,iy)
                      if (jpart.gt.0) write(lo,160)
                      if (npseud.gt.0) write(lo,140)
                      if (sc.lt.0.0) then
                                       write(lo,150)nrifl
                                     else
                                       write(lo,155)nrifl
                                     endif
                    endif
  140 format(32x,' pseudotranslational information')
  150 format(26x,i6,' not normalized reflections ')
  155 format(26x,i6,' normalized reflections ')
  160 format(32x,' fragment information')
      iprea=0
      call srlin (26,lsn,lfw,llw,lpb,ll)
      if(lfw.gt.0) then
      call sflxx(iprea,26,nsem1g,nsem1g,nstron,nxxe,iccd,mat)
      write(lo,244) nsem1g
                   endif
  244 format(26x,i6,' one phase seminvariants ')
      call srlin (27,lsn,lfw,llw,lpb,ll)
      if(lfw.gt.0) then
      call sflxx(iprea,27,nsem2,nsem2,nstron,nxxe,iccd,mat)
      write(lo,254) nsem2
                   endif
  254 format(26x,i6,' two phase seminvariants')
      call srlin (9,lsn,lfw,llw,lpb,ll)
      if(lfw.gt.0) then
      call sflxx(iprea,9,nps,nps,nrefp,nxxe,iccd,mat)
      write(lo,2500) nps
 2500 format(26x,i6,' psi-zero triplets ')
                   endif
      call srlin (24,lsn,lfw,llw,lpb,ll)
      if(lfw.gt.0) then
      call sflxx(iprea,24,ntot,ntrp,nreft,nxxe,iccd,mat)
      write(lo,6010) ntot
                   endif
 6010 format(26x,i6,' psi-e triplets')
      call srlin (8,lsn,lfw,llw,lpb,ll)
      if(lfw.gt.0) then
      call sflxx(iprea,8,ntot,ntrp,nreft,nxxe,iccd,mat)
      write(lo,4010) ntrp
                   endif
 4010 format(26x,i6,' positive triplets')
      call srlin (11,lsn,lfw,llw,lpb,ll)
      if(lfw.gt.0) then
      call sflxx(iprea,11,ntre,ntre,nreft,nxxe,iccd,mat)
      write(lo,4510) ntre
                   endif
 4510 format(26x,i6,' enantiomorph sensitive triplets')
      call srlin (10,lsn,lfw,llw,lpb,ll)
      if(lfw.gt.0) then
      call sflxx(iprea,10,ntrn,ntrn,nreft,nxxe,iccd,mat)
      write(lo,5010) ntrn
                   endif
 5010 format(26x,i6,' negative triplets')
      call srlin (20,lsn,lfw,llw,lpb,ll)
      if(lfw.gt.0) then
      call sflxx(iprea,20,nqn,nqn,nrefp,nxxe,iccd,mat)
      write(lo,5020) nqn
                   endif
 5020 format(26x,i6,' negative quartets ')
      call srlin (21,lsn,lfw,llw,lpb,ll)
      if(lfw.gt.0) then
      call sflxx(iprea,21,nqen,nqen,nrefp,nxxe,iccd,mat)
      write(lo,5030) nqen
                   endif
 5030 format(26x,i6,' enantiomorph sensitive quartets ')
      call srlin (16,lsn,lfw,llw,lpb,ll)
      if(lfw.gt.0) then
      call ysfl16(cfom,ipos,nset)
      write(lo,5040) nset
                   endif
 5040 format(26x,i6,' sets of phases')
      call srlin (15,lsn,lfw,llw,lpb,ll)
      if(lfw.gt.0) then
      idisp=1
      call sfl15(nats,idisp,numset,interp)
      if (numset.gt.0) then
                         write(lo,5050) nats,numset
                       else
                         write(lo,5060) nats
                       endif
                   endif
 5050 format(26x,i6,' coordinates related to set no.',i4)
 5060 format(26x,i6,' Patterson''s peaks')
      return
      end
c-----------------------------------------------------------------------
      subroutine histor(nfield,ivalue,ier)
c
c-- this subroutine is used to get the story of different
c-- attemps solving the actual structure
c
c     nfield = 1   information about pseudotranslational symmetry
c                  ( ivalue=0 if absent, ivalue= n if it exists with
c                    a percentage value of n , ivalue = -n if used )
c            = 2   information about partial procedure
c                  ( ivalue=1 if used , ivalue=0 otherwise )
c            = 3   number of symbols used
c            = 4   information about the use of seminvariants
c                  ( ivalue=1 if used , ivalue=0 otherwise )
c            = 5   information about the use of mess
c                  ( ivalue=1 if used , ivalue=0 otherwise )
c            = 6 - 16   not used
c
      character*80 filen
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
c
              if (kenvir.eq.0) then  
c-- standard sir91 environment
                                 kstory(nfield)=ivalue
         else if (kenvir.eq.1) then  
c-- enraf-nonius environment
c-- update the 170-th record (16 words lenght)
c-- in the master file for enraf-nonius implementation
c-- the record is red into kstory array, updated and rewritten
                                 namel=9
                                 filen(1:namel)='struc.nme'
                                 nrec=170
                                 jnon=30
                                 itipe=0
                                 nonius=16
         if (kopen(jnon,filen(1:namel),nonius,itipe,ierr).ge.0) then    
            read (jnon,rec=nrec,err=100,iostat=ierr) (kstory(i),i=1,16)
                                    kstory(nfield)=ivalue
            write(jnon,rec=nrec,err=120,iostat=ierr) (kstory(i),i=1,16)
                                    close(jnon)
                                  else
                                    ier=-1
                                    write(lo,90) ierr,filen(1:namel)
                                  endif
         else if (kenvir.eq.2) then  
                                 kstory(nfield)=ivalue
                               endif
      return
   90 format(' error ',i5,'  opening file ',a)
  100 ier=-1
      write(lo,110) ierr,nrec,filen(1:namel)
  110 format(' error ',i5,' reading record no. ',i3,' in file ',a)
      return
  120 ier=-1
      write(lo,130) ierr,nrec,filen(1:namel)
  130 format(' error ',i5,' writing record no. ',i3,' in file ',a)
      return
      end
c--------------------------------------------------------------------
      subroutine unpak3(index,kod1,kod2,ifaz)
      isave=index/32
      ifaz=index-isave*32 -1
      kod1=isave/4096
      kod2=isave-4096*kod1-2048
      kod1=kod1-2048
      return
      end
c-----------------------------------------------------
      subroutine besse(xx,vec)
c--bessel function
c
      x=abs(xx)
      vec=amin1((x+0.4807)*x/((x+0.8636)*x+1.3943),1.0)
      if (xx.lt.0.0) vec=-vec
      return
      end
c     ------------------------------------------------------------------
      subroutine musym(smat,tmat,n2,is,ts)
      integer is(2,3,24),smat(48,3,3)
      dimension ts(3,24),tmat(48,3)
c
c-----------------------------------------------------------------------
c
c     purpose
c             conversion of matricies in multan notation
c
c     usage
c             call musym(smat,tmat,n2,is,ts)
c
c     description of parameters
c
c             smat - 3-dimensionale array containing the rotational
c                    matricies computed by subroutine symm
c             tmat - bidimensional array containing the traslational
c                    matricies computed by subroutine symm
c             n2   - number of symmetry operators not related by
c                    a centre of symmetry
c             is   - 3-dimensional array containing the rotational
c                    matricies in multan notation
c             ts   - bidimensional array containing the traslational
c                    matricies in multan notation
c
c-----------------------------------------------------------------------
c
      do 10  j=1,2
      do 10 ja=1,3
      do 10 jb=1,n2
      is(j,ja,jb)=0
      ts(  ja,jb)=0
   10 continue
      do 50 jc=1,n2
      do 30  l=1,3
      m=1
      do 20  i=1,3
      if (smat(jc,l,i).eq.0) go to 20
      is(m,l,jc)=smat(jc,l,i)*i
      m=2
   20 continue
   30 continue
      do 40 ja=1,3
      ts(ja,jc)=tmat(jc,ja)
   40 continue
   50 continue
      return
      end
c-----------------------------------------------------------------------
      subroutine unpack (index,ih,kk,il)
      ih = index/262144
      is = index - 262144*ih
      kk = is/512-256
      il = is-512*(kk+256)-256
      return
      end
c ----------------------------------------------------------------------
      function bes(x)
      is=1
      if(x.lt.0.0) is=-1
      x1=abs(x)
      if(x1.lt.0.000001)  go to 200
      if(x1.le.2.9) go to 180
      if(x1.le.7.5) go to 160
      if(x1.le.20.) go to 140
      if(x1.le.39.) go to 120
      if(x1.le.45.) go to 100
      if(x1.le.55.) go to  80
      if(x1.le.65.) go to  60
      if(x1.le.80.) go to  40
      if(x1.le.99.) go to  20
      bes=1.*is
      return
   20 bes=0.0000631*x1+.988652
      bes=abs(bes)*is
      return
   40 bes=0.0000933*x1+.9862355
      bes=abs(bes)*is
      return
   60 bes=0.00014*x1+.9832
      bes=abs(bes)*is
      return
   80 bes=0.00021*x1+.97935
      bes=abs(bes)*is
      return
  100 bes=0.0000666*x1+.9858026
      bes=abs(bes)*is
      return
  120 bes=0.9459 +0.00187*x1-0.00002*x1*x1
      bes=abs(bes)*is
      return
  140 bes=0.82227+0.02189*x1-0.00114*x1*x1+0.00002*x1*x1*x1
      bes=abs(bes)*is
      return
  160 bes=0.444+0.19096*x1-0.02697*x1*x1+0.00135*x1*x1*x1
      bes=abs(bes)*is
      return
  180 bes=-0.00718+0.5668*x1-0.12287*x1*x1 +0.008*x1*x1*x1
      bes=abs(bes)*is
      return
  200 bes=0.
      return
      end
c ----------------------------------------------------------------------
      function besinv(y)
      if (abs(y).lt.0.000001)  go to  200
      if (y.le.0.6989)  go to 180
      if (y.le.0.8666) go to 160
      if (y.le.0.9259)  go to 140
      if (y.le.0.9553)  go to 120
      if (y.le.0.9635)  go to 100
      if (y.le.0.9884) go to 90
      if (y.le.0.9888) go to 80
      if (y.le.0.9909) go to 70
      if (y.le.0.9923) go to 60
      if (y.le.0.9937) go to 50
      if (y.le.0.9949) go to 40
      besinv=100.
      return
   40 besinv=15833.333*y-15653.583
      return
   50 besinv=10714.285*y-10566.785
      return
   60 besinv=7142.8571*y-7022.8571
      return
   70 besinv=4761.9047*y-4663.5713
      return
   80 besinv=15000*y-14787
      return
   90 besinv=49773.46954-102737.23532*y+53033.83171*y*y
      return
  100 besinv=77576.4096-162332.52722*y+84935.62155*y*y
      return
  120 besinv=3117.15834-6767.58257*y+3681.64105*y*y
      return
  140 besinv=486.69735-1127.7574*y+658.80603*y*y
      return
  160 besinv=-82.06253+344.25645*y-478.71058*y*y+226.35886*y*y*y
      return
  180 besinv=-0.00252+2.1065*y-1.12674*y*y+3.09414*y*y*y
      return
  200 besinv=0
      return
      end
c-----------------------------------------------------------------------
code for sortz
      subroutine sortz(lind,numb,iblk,jump)
c--sort the data in store
c
c  lind  addres in store
c  numb  number of block of data to be sorted
c  iblk  block lenght of the data (i.e. number of items per block)
c  jump  < 0 sort in decreasing order
c  jump  > 0 sort in increasing order
c  iabs(jump) = relative addres of the key of sort
c
      common /xdata/ store(244000)
c
      jsig=1
      if (jump.lt.0) then
                       jump=iabs(jump)
                       jsig=-1
                     endif
      if (numb.eq.1) return
      jump=jump-1
      ja=2
2010  continue
      jb=numb/ja
      if(jb) 2020,2020,2030
2020  continue
      jb=1
2030  continue
      jc=numb-jb
2040  continue
      jd=0
      m=lind
      do 2070 i=1,jc
      mk=m+jb*iblk
      if ((store(m+jump)-store(mk+jump))*jsig) 2060,2060,2050
 2050 continue
      mm=m
      mmk=mk
      do 2055 je=1,iblk
      f=store(mm)
      store(mm)=store(mmk)
      store(mmk)=f
      mm=mm+1
      mmk=mmk+1
 2055 continue
      jd=1
 2060 continue
      m=m+iblk
 2070 continue
      if (jd) 2080,2080,2040
 2080 continue
      if (jb-1) 2100,2100,2090
 2090 continue
      ja=ja*2
      go to 2010
 2100 continue
      return
      end
c-----------------------------------------------------
      subroutine stst
c--print the test (centro)
      common/tst/nt,ar(26),nn(11,26,3),pp(11,26,3)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /erl/ ksmat(48,3,3),tmat(48,3),nto(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym/isp(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emv
     *          ,s3s2p
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,ifper,iprin,iflag
      common /inp/  natom,fnat,satm,atoms
      common/prin/ ipt,ip0,ip10,ipq
      common /pseud/ kmat(48,3,3),emme,patom,qatom,npseud,lpseud(4,3)
     1         ,scale,jmme,prod,prod2,mjn(5,11),njn,coef,nw(8),no(8)
      dimension pa(11,26,3)
c
      write(lo,1000)
 1000 format(/,' number of relations(nr),number of correct rel.',
     2'(nc) and percentage(%) of correct relationship ')
      write(lo,1001)
 1001 format(///)
      write(lo,1010)
 1010 format(14x,'rel.posit.',20x,'rel.negat.',//,
     2 1x,5h arg.,2(9x,3hnr.,4x,3hnc.,4x,1h%,2x),/)
      do 1030 l=1,2
      do 1020 i=1,nt
      if (nn(1,i,l).gt.0) then
                            fn=float(nn(1,i,l))
                            pa(1,i,l)=pp(1,i,l)*100.0/fn
                          else
                            pa(1,i,l)=0.0
                          endif
 1020 continue
 1030 continue
      do 1050 i=1,nt
      if (nn(1,i,1).eq.0.and.nn(1,i,2).eq.0) go to 1050
      write(lo,1040)ar(i),(nn(1,i,l),pp(1,i,l),pa(1,i,l),l=1,2)
 1040 format(f5.1,2(5x,i7,2f7.1))
 1050 continue
      return
      end
c--------------------------------------------------
      subroutine nstst
c--print the test (non-centro)
c
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /erl/ ksmat(48,3,3),tmat(48,3),nto(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym/isp(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emv
     *          ,s3s2p
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,ifper,iprin,iflag
      common /inp/  natom,fnat,satm,atoms
      common/prin/ ipt,ip0,ip10,ipq
      common /pseud/ kmat(48,3,3),emme,patom,qatom,npseud,lpseud(4,3)
     1         ,scale,jmme,prod,prod2,mjn(5,11),njn,coef,nw(8),no(8)
      common /nctst/ ns,br(15),nb(11,15,3),fnb(11,15,3),bcm(11,15,3),
     *                        acm(11,15,3)
c
      write(lo,1000)
1000  format(' number of relationships(nr), percentages(%) of correct si
     *gns',/,' average errors in relationships')
      write(lo,1001)
 1001 format(///)
      en=float(mjn(1,1))/10.0
      write(lo,1010)
 1010 format(20x, 'positive rel.',25x,'negative rel.')
      write(lo,1020)
 1020 format(3x,2hg ,1x,2(8x,'nr.    %     <|phi|>         '),//)
      do 1100 j=1,3
      do 1090 i=1,ns
      if(nb(1,i,j)) 1090,1090,1030
 1030 continue
      fn=1.0/float(nb(1,i,j))
      fnb(1,i,j)=fnb(1,i,j)*fn*100.0
      bcm(1,i,j)=bcm(1,i,j)*fn
 1090 continue
 1100 continue
      do 1110 i=1,ns
*     do 1105 j=1,2
*     if (nb(1,i,j).gt.0) then
*                   arg=rtod*atan2( acm(1,i,j) , bcm(1,i,j))
*                   arg=rtod*atan( acm(1,i,j) / bcm(1,i,j))
*                   arg=amod(arg+3600.0,360.0)
*                   if (arg.gt.180.0) arg=360-arg
*                   bcm(1,i,j)=arg
*                 endif
*1105 continue
      write(lo,1120) br(i),(nb(1,i,j),fnb(1,i,j),bcm(1,i,j),j=1,2)
 1120 format(f5.1,3(5x,i7,f7.1,f9.3,9x))
 1110 continue
      return
      end
c------------------------------------------------------
      subroutine nctet(aa,cc,ang,j)
c--test for the correct coincidence (non-centro)
c
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /nctst/ ns,br(15),nb(11,15,3),fnb(11,15,3),bcm(11,15,3),
     *                        acm(11,15,3)
c
      if (aa.lt.0.0) then
                       kk=2
                     else
                       kk=1
                     endif
      bb=abs(aa)
      do 1100 i=1,ns
      ii=i
      if(br(i)-bb) 1020,1020,1200
1020  continue
       nb(j,ii,kk)= nb(j,ii,kk)+1
      bcm(j,ii,kk)=bcm(j,ii,kk)+ang
      a=aa*cc
      if(a) 1100,1030,1030
1030  continue
      fnb(j,ii,kk)=fnb(j,ii,kk)+1.0
1100  continue
1200  continue
      return
      end
c--------------------------------------------------------
      subroutine nclrt
c--prepare the test buffer (non-centro)
c
      common /nctst/ ns,br(15),nb(11,15,3),fnb(11,15,3),bcm(11,15,3),
     *                        acm(11,15,3)
c
      ns=15
      br(1)=0.0
      do 1100 i=2,6
      br(i)=br(i-1)+0.4
1100  continue
      do 1110 i=7,10
      br(i)=br(i-1)+0.6
1110  continue
      br(11)=5.5
      br(12)=6.5
      br(13)=9.0
      br(14)=15.0
      br(15)=20.0
      do 1140 k=1,11
      do 1140 j=1,3
      do 1150 i=1,ns
      nb (k,i,j)=0
      fnb(k,i,j)=0.0
      bcm(k,i,j)=0.0
      acm(k,i,j)=0.0
1150  continue
1140  continue
      return
      end
c-----------------------------------------------------
      subroutine clrt
c--prepare the test buffer (centro)
      common/tst/nt,ar(26),nn(11,26,3),pp(11,26,3)
      ar( 1)=.0
      ar( 2)=.2
      ar( 3)=.4
      ar( 4)=.6
      ar( 5)=.8
      ar( 6)=1.
      ar( 7)=1.2
      ar( 8)=1.4
      ar( 9)=1.6
      ar(10)=2.
      ar(11)=2.4
      ar(12)=2.8
      ar(13)=3.2
      ar(14)=3.4
      ar(15)=3.8
      ar(16)=4.2
      ar(17)=4.6
      ar(18)=5.0
      ar(19)=5.5
      ar(20)=6.0
      ar(21)=6.5
      ar(22)=7.
      ar(23)=7.5
      ar(24)=8.0
      ar(25)=8.5
      ar(26)=9.0
      nt=26
      do 100 k=1,11
      do 100 l=1,3
      do 200 i=1,nt
      nn(k,i,l)=0
      pp(k,i,l)=0
 200  continue
 100  continue
      return
      end
c----------------------------------------------------------
      subroutine sctst(aa,cc,j)
c--test for the correct coincidence (centro)
      common/tst/nt,ar(26),nn(11,26,3),pp(11,26,3)
c
      if(aa.lt.0) then
                    k=2
                  else
                    k=1
                  endif
      bb=abs(aa)
      do 1100 i=1,nt
      if(ar(i)-bb)1020,1020,1200
 1020 continue
      nn(j,i,k)=nn(j,i,k)+1
      if(cc)1100,1030,1030
 1030 continue
      pp(j,i,k)=pp(j,i,k)+1.0
 1100 continue
 1200 continue
      return
      end
c----------------------------------------------------------------------
      subroutine ucase(line)
      character*(*) line
      character*52 ulc
      common /ulcase/ ulc
      character a
c
      k=len(line)
      do 20 i=1,k
      a=line(i:i)
      l=0
      do 10 j=1,26
      if (a.eq.ulc(j:j)) l=j
   10 continue
      if (l.ne.0) line(i:i)=ulc(l+26:l+26)
   20 continue
      return
      end
c----------------------------------------------------------------------
      subroutine lcase(line)
      character*(*) line
      character*52 ulc
      common /ulcase/ ulc
      character a
c
      k=len(line)
      do 20 i=1,k
      a=line(i:i)
      l=0
      do 10 j=27,52
      if (a.eq.ulc(j:j)) l=j
   10 continue
      if (l.ne.0) line(i:i)=ulc(l-26:l-26)
   20 continue
      return
      end
c-----------------------------------------------------------------------
      subroutine wrhead
      character str*80,messh*80
      character fname(9)*80,ext(9)*4
      common/dotdat/ fname,ext
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
c
c-- write the Header
c
      k=index(fname(1),'.')
      call sirdate(str,icod)
      if (icod.eq.0) then
          messh=' SIR92 runs on:   '//fname(1)(1:k-1)
        else
          messh=str(1:icod)//' SIR92 runs on:   '//fname(1)(1:k-1)
        endif
c
      write(lo,10) messh
   10 format(1h ,a,//)
c
      return
      end
